/*
 
 (c) 2009-2013 Michael Leibman
 michael{dot}leibman{at}gmail{dot}com
 http://github.com/mleibman/slickgrid

 Distributed under MIT license.
 All rights reserved.

 SlickGrid v2.2

 NOTES:
     Cell/row DOM manipulations are done directly bypassing jQuery's DOM manipulation methods.
     This increases the speed dramatically, but can only be done safely because there are no event handlers
     or data associated with any cell/row DOM nodes.  Cell editors must make sure they implement .destroy()
     and do proper cleanup.
*/
const $a=globalThis,K=chrome.i18n?.getMessage||(()=>""),jb=chrome.runtime?.sendMessage||(()=>{});function pb(c){return atob(c).split("").map(f=>String.fromCharCode(f.charCodeAt(0)+1)).join("")}function qb(){chrome.tabs.create({url:zb.ja,active:!0}).then(c=>chrome.windows.update(c.windowId,{focused:!0}))}function Mb(c){return c?c.trim():""}function Wb(c,f){return c&&f&&c.startsWith(f)?c.slice(f.length):c}const Xb=Date[pb("bW52")]();
var jc=RegExp("^data:([^;]+)((?:;[^=]+=[^;]+)*)(?:;(base64))?,(.+)$"),kc=RegExp("^(?:(?:https?|ftp)://)?(?:\\S+(?::\\S*)?@)?(?:(?!(?:10|127)(?:\\.\\d{1,3}){3})(?!(?:169\\.254|192\\.168)(?:\\.\\d{1,3}){2})(?!172\\.(?:1[6-9]|2\\d|3[0-1])(?:\\.\\d{1,3}){2})(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))\\.?)(?::\\d{2,5})?(?:[/?#]\\S*)?$",
"i");
const lc={"3gpp":"3gp","3gpp2":"3g2",aiff:"aif","ms-asf":"asf",basic:"au",msvideo:"avi",binary:"bin",macbinary:"bin","octet-stream":"bin","windows-bmp":"bmp",bzip:"bz",bzip2:"bz2",java:"class","java-class":"class",msword:"doc","openxmlformats-officedocument.wordprocessingml.document":"docx",fortran:"f",icon:"ico","java-source":"java",jpeg:"jpg",pjpeg:"jpg",mpegurl:"m3u",rfc822:"mhtml",matroska:"mkv",quicktime:"mov",mpeg3:"mp3",mpeg:"mp4","sgi-movie":"mv",pascal:"p","portable-bitmap":"pbm","portable-floatmap":"pfm","portable-graymap":"pgm",
"portable-pixmap":"ppm",mspowerpoint:"ppt","ms-powerpoint":"ppt",powerpoint:"ppt","openxmlformats-officedocument.presentationml.presentation":"pptx","application/vnd.openxmlformats-officedocument.presentationml.slideshow":"ppsx",postscript:"ps","adobe.photoshop":"psd","script.phyton":"py","pn-realaudio":"ra","rn-realmedia":"rm",bsh:"sh","svg+xml":"svg",gnutar:"tgz",plain:"txt","ms-wma":"wma","ms-wmv":"wmv",excel:"xls",msexcel:"xls","ms-excel":"xls","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":"xlsx",
compressed:"zip","zip-compressed":"zip"};
function mc(c){c=(c||"").trim();var f={},k=14;if(c.startsWith("blob:")){for(;k--;)f[nc[k]]="";return f}if(0==c.indexOf("data:")){for(;k--;)f[nc[k]]="";f.protocol="data";(c=jc.exec(c))&&c[1]&&(c=c[1].match(/(?:[^\/]+)\/(?:x-)?(?:vnd\.)?(.+)/i))&&c[1]&&(f.file="download."+(lc[c[1]]||c[1]))}else try{const E=new URL(c);{var u=E.pathname;const G=u.lastIndexOf(".");if(-1==G||G==u.length-1)var q="";else{var n=u.lastIndexOf("/");q=n>G?"":u.slice(n+1)}}{var g=E.pathname;const G=g.lastIndexOf(".");if(-1==G||
G==g.length-1)var w=g;else{var r=g.lastIndexOf("/");w=r>G?g:g.substring(0,r+1)}}return{anchor:Wb(E.hash,"#"),authority:E.host,directory:w,file:q,host:E.host,password:E.password,path:E.pathname,port:E.port,protocol:E.protocol,query:Wb(E.search,"?"),relative:E.pathname,source:E.href,user:E.username,userInfo:E.username&&E.password?E.username+":"+E.password:E.username}}catch(E){for(console.error(E);k--;)f[nc[k]]=""}return f}var nc="source protocol authority userInfo user password host port relative path directory file query anchor".split(" ");
function oc(c){c=(c||"").trim();var f=c.lastIndexOf("."),k=-1!=f;k||(f=c.length);return{Ob:c.substr(0,f),oa:c.substr(f+1),Vb:k}}function pc(){var c=qc;c=c||"";var f=0==c.indexOf("data:"),k=c.indexOf("\r");-1==k&&(k=c.indexOf("\n"));-1!=k?c=c.substr(0,f?Math.min(k,1024):k):f&&1024<c.length&&(c=c.substr(0,1024));return f?jc.test(c):kc.test(c)}
function rc(c){return 1E3>c?+c.toFixed(2)+" B":1024E3>c?+(c/1024).toFixed(2)+" KB":1048576E3>c?+(c/1048576).toFixed(2)+" MB":+(c/1073741824).toFixed(2)+" GB"}var O=0;O=0;O++;O++;O++;O=0;O++;O++;O++;O++;O++;O++;O=0;var sc=O++;O++;O=0;var Kc=O++;O++;var Lc=O++,Mc=O++;O=0;var Nc=O++,Oc=O++,Pc=O++,Qc=O++,Rc=O++;O=0;var Sc=O++;O++;O++;O++;O++;O=0;var Tc=O++;O++;O=0;O++;O++;var Uc=O++;O=0;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O=0;O++;O++;O++;O=0;O++;O=256;O++;O++;O++;O++;O++;O++;
O=512;O++;O++;function Vc(){let c,f;return{promise:new Promise((k,u)=>{c=k;f=u}),resolve:c,reject:f}}const Wc=Xb>Number(pb("MDY0MDEzMDU4MDczNQ")),Xc=pb("bV4"),Yc=pb("YF4");function Zc(c){if(0===c)return"a";let f="";for(;0<c;)f="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"[c%62]+f,c=Math.floor(c/62);return f}let $c;
function ad(c){if(c&&(c="string"===typeof c?c:c.stack?c.stack:c.toString?c.toString():JSON.stringify(c))&&"string"===typeof c&&($c||($c=/extensions gallery cannot be scripted|cannot access contents of the page|extension manifest must request permission to access the respective host|could not establish connection|receiving end does not exist|frame with ID \d+|Filename not yet determined|no (tab|window) with id:|Tabs cannot be edited right now|The page keeping the extension port is moved into back\/forward cache/i),!$c.test(c)))return c.slice(0,
400)}const bd=pb("YV4"),cd=["",[String.fromCharCode(103),String.fromCharCode(108),String.fromCharCode(99)].join(""),"2_"].join("_");async function dd(c){c=cd+c;return(await chrome.storage.local.get(c))[c]}async function Bd(c){c=await dd(c);const f=Date.now();return!c||!c._t||isNaN(c._t)||!isFinite(c._t)||6048E5<f-c._t?{_t:f}:c}function Cd(c){return bd+btoa(c.split("").map(f=>{var k=f.charCodeAt(0),u=0;"_"!=f&&(u=60<k?-55:53);return String.fromCharCode(k+u)}).join("")).replace(/=+$/,"")}
async function Dd(c,f){var k=k||1;const u=await Bd(c);f=[f].map(q=>"string"===typeof q?q:Yc+Zc(q)).join(";");u[f]=(u[f]||0)+k;return chrome.storage.local.set({[cd+c]:u})}const Ed=[0,1,5,10,20,50,100,200,500,1E3,2E3,5E3,1E4,2E4,5E4,1E5,2E5,5E5,1E6];function Fd(c){if(0>=c)return Promise.resolve();var f=Ed;let k=0;for(;k<f.length&&c>=f[k];++k);k=Math.max(0,k-1);c=f[k];return Dd(5,(Xc+c).replace(/\./g,"_"))}
async function Gd(c){const f=await Bd(4);for(const [k,u]of Object.entries(c))c=k.replace(/[<>:"/\\|?*\x00-\x1F]/g,"").replace(/[^\x00-\x7F]/g,"_"),c=Cd(c),f[c]=(f[c]||0)+u;return chrome.storage.local.set({[cd+4]:f})}
const Hd={Za:"//downloads",Bb:"//extensions",ia:"//settings/downloads",ja:"//settings/languages",eb:"//settings/content/pdfDocuments",cb:(c="chrome:")=>`${c}//extensions/?id=${chrome.runtime.id}#allow-on-file-urls`},Id={Za:"chrome://downloads",ia:"chrome://settings/downloads",Db:"https://chromewebstore.google.com/detail/mciiogijehkdemklbdcbfkefimifhecn",za:"https://chromewebstore.google.com/detail/mciiogijehkdemklbdcbfkefimifhecn/reviews"};let Jd="Chrome";var Kd;
a:{const c=["Chrome","chrome",Id,"google"],f=[c,["Edge","edge",{},"microsoftedge"],["Firefox","",{ja:"about:preferences#general",cb:()=>"about:addons"},"mozilla"],["Opera","opera",{},"opera"],["360","se",{ia:"se://settings/browser#downloadsSection",ja:"se://settings",eb:"se://settings"},"360"],["QQ","qqbrowser",{ia:"qqbrowser://settings/normal?qbDownload"},"qq"]],k=chrome.runtime.getManifest().homepage_url;for(const u of f){const [q,,,n]=u;if(""===q||k.includes(n)){Kd=u;break a}}Kd=c}
const [Ld,Md,Nd]=Kd,Od={};if(Md)for(const c in Hd){const f=Hd[c];Od[c]="function"===typeof f?f.bind(void 0,Md+":"):Md+":"+f}Jd=Ld;const zb={Cb:"about:newtab",za:chrome.runtime.getManifest().homepage_url||Id.za,...Od,...(Nd||{})};var Pd;if("Edge"===Jd)Pd=K("optItemOverrideChromeNoShortcut");else{var Qd="Opera"!==Jd;Pd=K("optItemOverrideChrome",[(-1<navigator.platform.indexOf("Mac")?((Qd||"")&&"\u21e7")+"\u2318":"Ctrl+")+"J"])}var Rd=K("uilang");
const Sd={_uilanguage:{label:"",type:"button",value:void 0,Hb:K("chromesysChange"),onclick:function(){qb()}},fnconflict:{label:"When file name conflicts",type:"select",options:[K("optOptionUniquify"),K("optOptionOverwrite"),K("optOptionPrompt"),K("optOptionSkipPause"),K("optOptionSkipCancel")],value:Sc,g:"NameConflict"},def_threads:{label:K("fieldThreads"),type:"int",tb:!0,value:5,min:1,max:15},def_addtop:{label:K("optionAddTop"),type:"bool",value:!1},def_addpause:{label:"Add paused",type:"bool",
value:!1,g:"DefAddPaused"},down_clipboard:{label:"Download URL from Clipboard",type:"bool",value:!0,g:"DownloadClipboard"},start_interrupted:{label:"Start Button also starts interrupted tasks",type:"bool",value:!1,g:"StartInterrupted"},override_cr:{label:Pd,type:"bool",value:!0},hide_cr_bar:{label:"Hide Chrome's Downloads Shelf(Bar)",type:"bool",value:!0,g:"HideShelf"},win_mode:{label:"Open downloads manager as standalone window",type:"bool",value:!0,g:"WinMode"},slide_details_panel:{label:"Slide details panel when click on task",
type:"bool",value:!0,g:"SlideDetailsPanel",ha:K("tipOptItemSlideDetailsPanel")},recycle_cancel:{label:"Cancel the task when it's recycled",type:"bool",value:!1,g:"RecycleCancel"},clear_search:{label:"Clear search box when filter changes",type:"bool",value:!1,g:"ClearSearch"},menu_d_dialog:{label:K("menuDLink"),type:"bool",value:!0},menu_d_oneclick:{label:K("menuDLinkOneClick"),type:"bool",value:!0},menu_d_sniffer:{label:K("tipBrowserAction"),type:"bool",value:!0},notify_error:{label:"When error occurs",
type:"bool",value:!0,g:"NotifyError"},notify_finish:{label:"When download completes",type:"bool",value:!0,g:"NotifyFinish"},sound_finish:{label:"Play sound when download completes",type:"bool",value:!0,g:"SoundFinish"},sound_error:{label:"Play sound when error occurs",type:"bool",value:!0,g:"SoundError"},notify_oneclick:{label:"When adding One-Click download",type:"bool",value:!1,g:"NotifyOneClick"},notify_progress:{label:"Show download progress",type:"bool",value:!1,g:"NotifyProgress"},notify_large_preview:{label:"Show large preview for images",
type:"bool",value:!0,g:"NotifyLargePreview"},click_notify:{label:"Clicking on a notification",type:"select",options:[[K("optOptionOpenFile"),Qc],[K("optOptionOpenFolder"),Rc],[K("menuOpenManager"),Nc],[K("optOptionClearNotify"),Oc],[K("optOptionClearAllNotify"),Pc]],value:Qc,g:"ClickNotify"},dbclick_action:{label:"Double-click on task",type:"select",options:[[K("optOptionDoNothing"),Kc],[K("optOptionOpenFile"),Lc],[K("optOptionOpenFolder"),Mc]],value:Mc,g:"DblClickAction"},doneclick_rule:{label:K("phraseEnable"),
type:"bool",value:!0,ha:K("tipOptSectionOneClick"),ac:"https://faq.chronodownloader.net/?action=faq&cat=7&id=3"},badge_downnum:{label:"Show Downloading Number",type:"bool",value:!0,g:"BadgeDownloadNum"},font_size:{label:K("chromesysFontSize"),type:"int",value:14,min:12,max:16},poplist_max_items:{label:"Max Items",type:"int",value:15,min:1,max:50,g:"PopMaxItems"},poplist_showd_first:{label:"Show downloading tasks first",type:"bool",value:!0,g:"PopShowDLFirst"},poplist_clear_close:{label:"Close after clear",
type:"bool",value:!1,g:"PopClearClose"},dy_max_con_tasks:{label:"Concurrent downloads",type:"int",value:10,min:1,max:20,g:"ConcurrentDownloads"},dy_max_per_server:{label:"Downloads per server",type:"int",value:5,min:1,max:5,g:"DownloadsPerServer"},always_use_last_location:{label:Rd.startsWith("en")||Rd.startsWith("zh")?K("labelUseLastLocation"):K("labelFolderColon")+" "+K("labelUseLastLocation"),type:"bool",value:!0},chrono_folder_selection:{label:K("labelEnableFolderSelection"),type:"bool",value:!0},
folder_inaccessible:{label:K("labelUnableSaveToFolder"),type:"select",options:[K("labelDownloadToDefaultFolder"),K("labelChooseDownloadLocation")],value:Tc},def_folder:{label:"Default folder",type:"string",value:"",tb:!0,ha:K("tipOptNoRuleMatch"),g:"DefFolder"},def_naming:{label:"Default Naming Mask",type:"string",value:"*name*.*ext*",Ka:"*name*.*ext*",ha:K("tipOptNoRuleMatch"),g:"DefNaming"},match_mode:{label:"Match Mode",type:"select",options:[K("optOptionFirstMatch"),K("optOptionReplace")],value:sc,
ha:K("tipOptItemRuleMatchMode"),g:"RuleMatchMode"},tb_fit_cols:{type:"bool",value:!1},tb_sync_resize:{type:"bool",value:!1},tb_def_cols:{type:"list",value:"state name progress size speed active_threads time_remained url time_add".split(" ")},tb_sort_cols:{type:"list",value:[{field:"time_add",sortAsc:!1}]},pop_preview:{type:"bool",value:!0},pop_showsize:{type:"bool",value:!0},pop_content:{type:"int",value:0,min:void 0,max:void 0},pop_sniffer_hint:{type:"int",value:0,min:void 0,max:void 0},pop_clear_file:{type:"bool",
value:!1},poplist_remove_confirm:{type:"select",value:Uc,g:"PopDeleteAction",label:"Click 'Delete' button",options:[K("optOptionRemList"),K("optOptionRemFile"),K("optOptionRemAsk")]},preview_autoplay:{type:"bool",value:!1,label:`${K("optSectionPreview")} - ${K("optItemPreviewAutoplay")}`},bg_image_enable:{type:"bool",value:!1},bg_image_everset:{type:"bool",value:!1},bg_image_url:{type:"string",value:"/icons/bg/1.jpg"},bg_image_opacity:{type:"float",value:.35,min:0,max:1},bg_image_blur:{type:"int",
value:0,min:0,max:10},ui_grid_list:{type:"bool",value:!0},autoclear_type:{type:"string",value:"both"},autoclear_timer:{type:"int",value:-1,min:void 0,max:void 0},search_mode:{type:"string",value:"normal"},search_case_sensitive:{type:"bool",value:!1}};
class Td{constructor(){this.la=Sd}load(){this.Aa||(this.Aa=chrome.storage.sync.get(Object.keys(Sd)).then(c=>{for(const f in c){const k=c[f];void 0!==k&&null!==k&&(this.la[f].value=k)}}));return this.Aa}get(c){return(c=this.la[c])?""===c.value&&void 0!==c.Ka?c.Ka:c.value:null}set(c,f){const k=this.la[c];if(!k||void 0!==k.min&&f<k.min||void 0!==k.max&&f>k.max)return!1;k.value=f;this.Da(c,f);return!0}Da(){throw Error("not implemented");}}
const Ud=new class extends Td{Da(c,f){jb({cmd:"s_s",data:[c,f]})}},Vd=Ud.load();function Wd(){Ud.load().then(()=>{var c=Ud.get("font_size");document.documentElement.classList.contains("fs-none")||(document.documentElement.style.fontSize&&document.documentElement.classList.remove("fs-"+document.documentElement.style.fontSize),document.documentElement.style.fontSize=c+"px",document.documentElement.classList.add("fs-"+c+"px"))})}
function Xd(c){if(c.R)return c.R;const f=Vc();c.R=f.promise;const k=()=>{const u=document.createElement("iframe");u.style.display="none";setTimeout(()=>{c.s||Dd(96,156)},6E3);window.addEventListener("message",q=>{if(c.ca.includes(q.origin))switch(q.data.type){case "IFRAME_READY":const [n,g]=q.data.data;c.s=u;f.resolve([n,g]);break;case "CLOSE_CONSENT":c.s&&c.s.classList.toggle("showConsent",!1)}});u.src=c.ca;document.body.appendChild(u)};"loading"===document.readyState?document.addEventListener("DOMContentLoaded",
()=>{setTimeout(k,2500)},{once:!0}):setTimeout(k,2500);return c.R}async function Yd(c){var f=Zd;f.O.push(["gtag_event",c]);f.s||await Xd(f);c=f.s.contentWindow;if(f.O.length)for(;0<f.O.length;){const k=f.O.shift();k&&c.postMessage({type:k[0],data:k[1]},f.targetOrigin)}}async function $d(c,f){Yd([c,f])}
class ae{constructor(){var c={ca:"https://app.chronodownloader.net/ga.html"};this.R=this.s=null;this.O=[];this.ca=c.ca;this.targetOrigin=c.targetOrigin||"*"}destroy(){this.s&&(document.body.removeChild(this.s),this.s=null);this.R=null;this.O=[]}}const Zd=new ae,be=(c,f,k)=>{$d(Yc+Zc(c),{["string"===typeof f?f:Yc+Zc(f)]:"string"===typeof k?k:Yc+Zc(k),page_location:location.href,v:chrome.runtime?.getManifest?.()?.version})};($a.__cdmg__=$a.__cdmg__||{}).r=be;
function ce(){function c(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+f+"]"),q=0;q<u.length;++q)u[q][k]=K(u[q].attributes[f].value),u[q].removeAttribute(f)}c("text","innerText");c("title","title");c("href","href");c("placeholder","placeholder");(function(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+f+"]"),q=0;q<u.length;++q)u[q].setAttribute(k,K(u[q].attributes[f].value)),u[q].removeAttribute(f)})("tooltip","data-tooltip");(function(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+
f+"]"),q=0;q<u.length;++q){var n=u[q].attributes[f].value.split(","),g=n[0];n.shift();u[q][k]=K(g,n);u[q].removeAttribute(f)}})("textparams","innerText")}const de=new Map;
class ee{constructor(c){this.ka=c}async get(c,f){let k=!1;Array.isArray(c)||(k=!0,c=[c],f=[f]);f=f??[];const u=[],q=await this.ka.get(c);for(let E=0;E<c.length;++E){var n=c[E],g=q[n];if(void 0!==g)u.push(g);else{g=u;var w=g.push,r=f[E];let G=de.get(n);void 0===G&&void 0!==r&&(G=r,de.set(n,G));w.call(g,G)}}return k?u[0]:u}set(c,f){return this.ka.set({[c]:f})}erase(c){return this.ka.remove(c)}}const fe=new ee(chrome.storage.session),ge=new ee(chrome.storage.sync);
let he=[{caption:K("extsImage"),int_name:"ext_image",exts:"bmp|cur|dds|exr|gif|ico|jpg|jpeg|pcx|pbm|pfm|pgm|ppm|png|psd|svg|tga|tif|tiff|webp",filter_links:!0},{caption:K("extsVideo"),int_name:"ext_video",exts:"3gp|3g2|asf|avi|f4f|f4i|f4m|f4v|flv|h264|m4v|mkv|mov|mp4|mpg|ogg|ogv|qt|rm|rmvb|ts|vob|webm|wmv",filter_links:!0},{caption:K("extsAudio"),int_name:"ext_audio",exts:"aac|aif|ape|flac|oga|opus|m3u|m4a|mid|midi|mp3|ra|wav|wma|weba",filter_links:!0},{caption:K("extsDocument"),int_name:"ext_doc",
exts:"c|cfg|cpp|cs|css|csv|dat|doc|docx|h|hpp|ini|js|log|m|pdf|ppt|pptx|ps|py|rtf|sh|tex|torrent|txt|xls|xlsx",filter_links:!0},{caption:K("extsArchive"),int_name:"ext_arch",exts:"7z|bin|cbr|cue|deb|dmg|gz|iso|mdf|pkg|rar|rpm|sitx|tar.gz|vcd|zip",filter_links:!0},{caption:K("extsApp"),int_name:"ext_app",exts:"apk|app|bat|cgi|com|dll|exe|gadget|jar|msi|pif|sys",filter_links:!0},{caption:K("extsAll"),int_name:"ext_all",exts:"[ext_audio]|[ext_video]|[ext_image]|[ext_doc]|[ext_arch]|[ext_app]",filter_links:!1}];
function ie(c,f,k){return f.replace(/\[([^\]]+)\]/gi,(u,q)=>{u=q?q.trim().toLowerCase():"";if(1==k[u])throw"loop of link filter ["+u+"] detected";k[u]=!0;a:{for(q=0;q<he.length;++q)if(he[q].int_name==u)try{var n=ie(c,he[q].exts,k);break a}catch(g){console.log(g);break}n=null}delete k[u];if(!n)throw"ref link filter ["+u+"] not found";return"("+n+")"})}function je(c){var f=ke;const k={};let u=null;if(0<=c&&c<he.length)try{u=ie(f,he[c].exts,k)}catch(q){console.log(q)}return u}
const ke=new class{constructor(){this.Ca=!1}async load(c){if(c||!this.Ca)(c=await ge.get("lfilters"))&&(he=c),this.Ca=!0}},le=Date.now();
function me(){var c;chrome.runtime.sendMessage({cmd:"naming_list"},function(f){if(f&&f.list){c=c||{};const q=document.getElementById("naming_history");for(;q.lastElementChild;)q.removeChild(q.lastElementChild);for(var k=0,u=f.list.length;k<u;++k){let n=f.list[k];if(!n)continue;let g;c.process?g=c.process(n):(g=document.createElement("option"),g.setAttribute("value",n));g&&q.appendChild(g)}c.jb&&c.jb(q)}})}
if(Wc&&window.top===window.self){const c=["QEFCV1hZ","cmtoYmQ","YGtkcXM","YmtucmQ"],f=c[0],k=pb(c[1]),u=pb(f)[k](3,5),q=K(u),n=pb(c[2]),g=pb(c[3]);window[n](q);window[g]()}function ne(){document.oncontextmenu=function(c){if(c.target){var f=c.target.nodeName.toLowerCase(),k=c.target.type&&c.target.type.toLowerCase();if(!c.target.classList.contains("allow-ctx-menu")&&(c.target.disabled||"textarea"!=f&&("input"!=f||"text"!=k&&"number"!=k)))return!1}}}
(function(c){function f(){var g=!1,w=!1;this.stopPropagation=function(){g=!0};this.isPropagationStopped=function(){return g};this.stopImmediatePropagation=function(){w=!0};this.isImmediatePropagationStopped=function(){return w}}function k(){this.Ba=!0}function u(){this.L=!0;this.count=this.level=0;this.title=this.value=null;this.collapsed=!1;this.I=null;this.rows=[];this.P=this.groups=null}function q(){this.X=!0;this.group=null;this.da=!1}function n(){var g=null;this.isActive=function(w){return w?
g===w:null!==g};this.activate=function(w){if(w!==g){if(null!==g)throw"SlickGrid.EditorLock.activate: an editController is still active, can't activate another editController";if(!w.commitCurrentEdit)throw"SlickGrid.EditorLock.activate: editController must implement .commitCurrentEdit()";if(!w.cancelCurrentEdit)throw"SlickGrid.EditorLock.activate: editController must implement .cancelCurrentEdit()";g=w}};this.deactivate=function(w){if(g!==w)throw"SlickGrid.EditorLock.deactivate: specified editController is not the currently active one";
g=null};this.commitCurrentEdit=function(){return g?g.commitCurrentEdit():!0};this.cancelCurrentEdit=function(){return g?g.cancelCurrentEdit():!0}}c.extend(!0,window,{Slick:{Event:function(){var g=[];this.subscribe=function(w){g.push(w)};this.unsubscribe=function(w){for(var r=g.length-1;0<=r;r--)g[r]===w&&g.splice(r,1)};this.notify=function(w,r,E){r=r||new f;E=E||this;for(var G,J=0;J<g.length&&!r.isPropagationStopped()&&!r.isImmediatePropagationStopped();J++)G=g[J].call(E,r,w);return G}},EventData:f,
EventHandler:function(){var g=[];this.subscribe=function(w,r){g.push({event:w,handler:r});w.subscribe(r);return this};this.unsubscribe=function(w,r){for(var E=g.length;E--;)if(g[E].event===w&&g[E].handler===r){g.splice(E,1);w.unsubscribe(r);return}return this};this.unsubscribeAll=function(){for(var w=g.length;w--;)g[w].event.unsubscribe(g[w].handler);g=[];return this}},Range:function(g,w,r,E){void 0===r&&void 0===E&&(r=g,E=w);this.fromRow=Math.min(g,r);this.fromCell=Math.min(w,E);this.toRow=Math.max(g,
r);this.toCell=Math.max(w,E);this.isSingleRow=function(){return this.fromRow==this.toRow};this.isSingleCell=function(){return this.fromRow==this.toRow&&this.fromCell==this.toCell};this.contains=function(G,J){return G>=this.fromRow&&G<=this.toRow&&J>=this.fromCell&&J<=this.toCell};this.toString=function(){return this.isSingleCell()?"("+this.fromRow+":"+this.fromCell+")":"("+this.fromRow+":"+this.fromCell+" - "+this.toRow+":"+this.toCell+")"}},NonDataRow:k,Group:u,GroupTotals:q,EditorLock:n,GlobalEditorLock:new n}});
u.prototype=new k;u.prototype.nb=function(g){return this.value===g.value&&this.count===g.count&&this.collapsed===g.collapsed&&this.title===g.title};q.prototype=new k})(jQuery);if("undefined"===typeof jQuery)throw"SlickGrid requires jquery module to be loaded";if(!jQuery.fn.drag)throw"SlickGrid requires jquery.event.drag module to be loaded";if("undefined"===typeof Slick)throw"slick.core.js not loaded";
(function(c){c.extend(!0,window,{Slick:{Grid:function(u,q,n,g){function w(){db||(db=!0,Oa=parseFloat(c.css(ta[0],"width",!0)),V(),ba(Ca),g.enableTextSelectionOnCells||Ha.bind("selectstart.ui",function(a){return c(a.target).is("input,textarea")}),Pa(),qa(),M(),N(),ua(),Y(),ta.bind("resize.slickgrid",ua),Ha.bind("scroll",h),Ab.bind("contextmenu",pe).bind("click",qe).delegate(".slick-header-column","mouseenter",re).delegate(".slick-header-column","mouseleave",se),eb.bind("scroll",d),Yb.add(tc).bind("keydown",
fb).bind("focusin",function(){ta.addClass("is-focused")}).bind("focusout",function(){ta.removeClass("is-focused")}),La.bind("keydown",fb).bind("click",te).bind("dblclick",ue).bind("contextmenu",ve).bind("draginit",P).bind("dragstart",{lb:3},R).bind("drag",la).bind("dragend",ma).delegate(".slick-cell","mouseenter",we).delegate(".slick-cell","mouseleave",xe),navigator.userAgent.toLowerCase().match(/webkit/)&&navigator.userAgent.toLowerCase().match(/macintosh/)&&La.bind("mousewheel",F))}function r(a){for(var b=
mb.length;0<=b;b--)if(mb[b]===a){mb[b].destroy&&mb[b].destroy();mb.splice(b,1);break}}function E(){for(var a=0,b=0,e=n.length;b<e;b++)a+=n[b].width;a+=f.width;return Math.max(a,Oa)+1E3}function G(){for(var a=kb?Oa-f.width:Oa,b=0,e=n.length;e--;)b+=n[e].width;return g.fullWidthRows?Math.max(b,a):b}function J(a){var b=gb;gb=G();gb!=b&&(La.width(gb),rb.width(gb),Ca.width(E()));uc=gb>Oa-(kb?f.width:0);ed.width(gb+(kb?f.width:0));(gb!=b||a)&&D()}function ba(a){a&&a.jquery&&a.attr("unselectable","on").css("MozUserSelect",
"none").bind("selectstart.ui",function(){return!1})}function Y(){for(var a=La[0];(a=a.parentNode)!=document.body&&null!=a;)if(a==Ha[0]||a.scrollWidth!=a.clientWidth||a.scrollHeight!=a.clientHeight){var b=c(a);Bb=Bb?Bb.add(b):b;b.bind("scroll."+Qa,fd)}}function qa(){function a(){c(this).addClass("ui-state-hover")}function b(){c(this).removeClass("ui-state-hover")}Ca.find(".slick-header-column").each(function(){var A=c(this).data("column");A&&B(T.Oa,{node:this,column:A})});Ca.empty();Ca.width(E());
rb.find(".slick-headerrow-column").each(function(){var A=c(this).data("column");A&&B(T.vb,{node:this,column:A})});rb.empty();for(var e=0;e<n.length;e++){var l=n[e],x=c("<div class='ui-state-default slick-header-column' />").html("<span class='slick-column-name'>"+l.name+"</span>").width(l.width-sb).attr("id",""+Qa+l.id).attr("title",l.toolTip||"").data("column",l).addClass(l.headerCssClass||"").appendTo(Ca);if(g.enableColumnReorder||l.sortable)x.on("mouseenter",a).on("mouseleave",b);l.sortable&&(x.addClass("slick-header-sortable"),
x.append("<span class='slick-sort-indicator' />"));B(T.Pa,{node:x[0],column:l});g.showHeaderRow&&(x=c("<div class='ui-state-default slick-headerrow-column l"+e+" r"+e+"'></div>").data("column",l).appendTo(rb),B(T.wb,{node:x[0],column:l}))}xa(Ra);va();g.enableColumnReorder&&Ia()}function M(){Ca.click(function(a){if(1==a.which&&(a.metaKey=a.metaKey||a.ctrlKey,!c(a.target).hasClass("slick-resizable-handle"))){var b=c(a.target).closest(".slick-header-column");if(b.length&&(b=b.data("column"),b.sortable&&
W().commitCurrentEdit())){for(var e=null,l=0;l<Ra.length;l++)if(Ra[l].columnId==b.id){e=Ra[l];e.sortAsc=!e.sortAsc;break}a.metaKey&&g.multiColumnSort?e&&Ra.splice(l,1):((a.shiftKey||a.metaKey)&&g.multiColumnSort||(Ra=[]),e?0==Ra.length&&Ra.push(e):(e={columnId:b.id,sortAsc:b.defaultSortAsc},Ra.push(e)));xa(Ra);g.multiColumnSort?B(T.onSort,{multiColumnSort:!0,Zb:c.map(Ra,function(x){return{sortCol:n[Sa[x.columnId]],sortAsc:x.sortAsc}})},a):B(T.onSort,{multiColumnSort:!1,sortCol:b,sortAsc:e.sortAsc},
a)}}})}function Ia(){Ca.filter(":ui-sortable").sortable("destroy");Ca.sortable({Nb:"parent",lb:3,axis:"x",cursor:"default",bc:"intersection",pa:"clone",placeholder:"slick-sortable-placeholder ui-state-default slick-header-column",start:function(a,b){b.placeholder.width(b.pa.outerWidth()-sb);c(b.pa).addClass("slick-header-column-active")},Gb:function(a,b){c(b.pa).removeClass("slick-header-column-active")},stop:function(a){if(W().commitCurrentEdit()){for(var b=Ca.sortable("toArray"),e=[],l=0;l<b.length;l++)e.push(n[Sa[b[l].replace(Qa,
"")]]);Va(e);B(T.onColumnsReordered,{});a.stopPropagation();va()}else c(this).sortable("cancel")}})}function va(){var a,b,e,l,x,A,H;var Z=Ca.children();Z.find(".slick-resizable-handle").remove();Z.each(function(ca){n[ca].resizable&&(void 0===A&&(A=ca),H=ca)});void 0!==A&&Z.each(function(ca,X){ca<A||g.forceFitColumns&&ca>H||(c(X),c("<div class='slick-resizable-handle' />").appendTo(X).bind("dragstart",function(pa){if(!W().commitCurrentEdit())return!1;e=pa.pageX;c(this).parent().addClass("slick-header-column-active");
var na=pa=null;Z.each(function(Ma,Nb){n[Ma].h=c(Nb).outerWidth()});if(g.forceFitColumns)for(na=pa=0,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(null!==na&&(na=b.maxWidth?na+(b.maxWidth-b.h):null),pa+=b.h-Math.max(b.minWidth||0,nb));var ea=0,Na=0;for(a=0;a<=ca;a++)b=n[a],b.resizable&&(null!==Na&&(Na=b.maxWidth?Na+(b.maxWidth-b.h):null),ea+=b.h-Math.max(b.minWidth||0,nb));null===pa&&(pa=1E5);null===ea&&(ea=1E5);null===na&&(na=1E5);null===Na&&(Na=1E5);x=e+Math.min(pa,Na);l=e-Math.min(ea,na)}).bind("drag",
function(pa){var na=Math.min(x,Math.max(l,pa.pageX))-e;if(0>na){var ea=na;for(a=ca;0<=a;a--)b=n[a],b.resizable&&(pa=Math.max(b.minWidth||0,nb),ea&&b.h+ea<pa?(ea+=b.h-pa,b.width=pa):(b.width=b.h+ea,ea=0));if(g.forceFitColumns)for(ea=-na,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(ea&&b.maxWidth&&b.maxWidth-b.h<ea?(ea-=b.maxWidth-b.h,b.width=b.maxWidth):(b.width=b.h+ea,ea=0))}else{ea=na;for(a=ca;0<=a;a--)b=n[a],b.resizable&&(ea&&b.maxWidth&&b.maxWidth-b.h<ea?(ea-=b.maxWidth-b.h,b.width=b.maxWidth):(b.width=
b.h+ea,ea=0));if(g.forceFitColumns)for(ea=-na,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(pa=Math.max(b.minWidth||0,nb),ea&&b.h+ea<pa?(ea+=b.h-pa,b.width=pa):(b.width=b.h+ea,ea=0))}Ba();g.$b&&D()}).bind("dragend",function(pa){c(this).parent().removeClass("slick-header-column-active");for(a=0;a<Z.length;a++){b=n[a];var na=c(Z[a]).outerWidth();b.h!==na&&b.rerenderOnResize&&Da()}J(!0);C();c(pa.toElement).one("click",function(ea){ea.stopImmediatePropagation()});B(T.onColumnsResized,{})}).bind("dblclick",
function(){B(T.onColumnResizerDblClick,{column:n[ca]})}))})}function Q(a){var b=0;c.each(["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"],function(e,l){b+=parseFloat(a.css(l))||0});return b}function V(){var a=["borderLeftWidth","borderRightWidth","paddingLeft","paddingRight"],b=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"];var e=c("<div class='ui-state-default slick-header-column' style='visibility:hidden'>-</div>").appendTo(Ca);sb=gd=0;"border-box"!=e.css("box-sizing")&&
"border-box"!=e.css("-moz-box-sizing")&&"border-box"!=e.css("-webkit-box-sizing")&&(c.each(a,function(x,A){sb+=parseFloat(e.css(A))||0}),c.each(b,function(x,A){gd+=parseFloat(e.css(A))||0}));e.remove();var l=c("<div class='slick-row' />").appendTo(La);e=c("<div class='slick-cell' id='' style='visibility:hidden'>-</div>").appendTo(l);vc=wc=0;"border-box"!=e.css("box-sizing")&&"border-box"!=e.css("-moz-box-sizing")&&"border-box"!=e.css("-webkit-box-sizing")&&(c.each(a,function(x,A){vc+=parseFloat(e.css(A))||
0}),c.each(b,function(x,A){wc+=parseFloat(e.css(A))||0}));l.remove();nb=Math.max(sb,vc)}function N(){tb=c("<style type='text/css' rel='stylesheet' />").appendTo(c("head"));var a=g.rowHeight-wc;a=["."+Qa+" .slick-header-column { left: 1000px; }","."+Qa+" .slick-top-panel { height:"+g.topPanelHeight+"px; }","."+Qa+" .grid-inner-top-panel { height:"+g.innerTopPanelHeight+"px; }","."+Qa+" .slick-headerrow-columns { height:"+g.headerRowHeight+"px; }","."+Qa+" .slick-cell { height:"+a+"px; text-align:center; vertical-align: middle; }",
"."+Qa+" .slick-row { height:"+g.rowHeight+"px; line-height:"+a+"px; }"];for(var b=0;b<n.length;b++)a.push("."+Qa+" .l"+b+" { }"),a.push("."+Qa+" .r"+b+" { }");tb[0].styleSheet?tb[0].styleSheet.cssText=a.join(" "):tb[0].appendChild(document.createTextNode(a.join(" ")))}function B(a,b,e){e=e||new Slick.EventData;b=b||{};b.grid=T;return a.notify(b,e,T)}function W(){return g.editorLock}function Ea(){var a,b=[],e=0,l=0,x,A=kb?Oa-f.width:Oa;for(a=0;a<n.length;a++){var H=n[a];b.push(H.width);l+=H.width;
H.resizable&&(e+=H.width-Math.max(H.minWidth,nb))}for(x=l;l>A&&e;){var Z=(l-A)/e;for(a=0;a<n.length&&l>A;a++){H=n[a];var ca=b[a];if(!(!H.resizable||ca<=H.minWidth||ca<=nb)){H=Math.max(H.minWidth,nb);var X=Math.floor(Z*(ca-H))||1;X=Math.min(X,ca-H);l-=X;e-=X;b[a]-=X}}if(x<=l)break;x=l}for(x=l;l<A;){e=A/l;for(a=0;a<n.length&&l<A;a++)H=n[a],Z=b[a],H=!H.resizable||H.maxWidth<=Z?0:Math.min(Math.floor(e*Z)-Z,H.maxWidth-Z||1E6)||1,l+=H,b[a]+=H;if(x>=l)break;x=l}l=!1;for(a=0;a<n.length;a++)n[a].rerenderOnResize&&
n[a].width!=b[a]&&(l=!0),n[a].width=b[a];Ba();J(!0);l&&(Da(),C())}function Ba(){if(db){for(var a,b=0,e=Ca.children(),l=e.length;b<l;b++)a=c(e[b]),a.width()!==n[b].width-sb&&a.width(n[b].width-sb);Pa()}}function D(){for(var a,b,e=0,l,x=0;x<n.length;x++){l=n[x].width;var A;b=x;if(!ub){var H=document.styleSheets;for(a=0;a<H.length;a++)if((H[a].ownerNode||H[a].owningElement)==tb[0]){ub=H[a];break}if(!ub)throw Error("Cannot find stylesheet.");xc=[];yc=[];H=ub.cssRules||ub.rules;for(a=0;a<H.length;a++){var Z=
H[a].selectorText;if(A=/\.l\d+/.exec(Z))A=parseInt(A[0].substr(2,A[0].length-2),10),xc[A]=H[a];else if(A=/\.r\d+/.exec(Z))A=parseInt(A[0].substr(2,A[0].length-2),10),yc[A]=H[a]}}a=xc[b];b=yc[b];a.style.left=e+"px";b.style.right=gb-e-l+"px";e+=n[x].width}}function xa(a){Ra=a;var b=Ca.children();b.removeClass("slick-header-column-sorted").find(".slick-sort-indicator").removeClass("slick-sort-indicator-asc slick-sort-indicator-desc");c.each(Ra,function(e,l){null==l.sortAsc&&(l.sortAsc=!0);e=Sa[l.columnId];
null!=e&&b.eq(e).addClass("slick-header-column-sorted").find(".slick-sort-indicator").addClass(l.sortAsc?"slick-sort-indicator-asc":"slick-sort-indicator-desc")})}function ra(a,b){zc=[];for(var e={},l=0;l<b.length;l++)for(var x=b[l].fromRow;x<=b[l].toRow;x++){e[x]||(zc.push(x),e[x]={});for(var A=b[l].fromCell;A<=b[l].toCell;A++)hd(x,A)&&(e[x][n[A].id]=g.selectedCellCssClass)}y(g.selectedCellCssClass,e);B(T.onSelectedRowsChanged,{rows:Zb()},a)}function Pa(){Cb=[];Db=[];for(var a=0,b=0,e=n.length;b<
e;b++)Cb[b]=a,Db[b]=a+n[b].width,a+=n[b].width}function Va(a){n=a;Sa={};for(a=0;a<n.length;a++){var b=n[a]=c.extend({},Ac,n[a]);Sa[b.id]=a;b.minWidth&&b.width<b.minWidth&&(b.width=b.minWidth);b.maxWidth&&b.width>b.maxWidth&&(b.width=b.maxWidth)}Pa();db&&(Da(),qa(),tb.remove(),ub=null,N(),ua(),D(),h())}function ya(){return q.getLength?q.getLength():q.length}function Ta(){return ya()+(g.enableAddRow?1:0)}function za(a){return q.getItem?q.getItem(a):q[a]}function Wa(a){return Math.floor((a+Ja)/g.rowHeight)}
function L(a){a=Math.max(a,0);a=Math.min(a,ab-Fa+(uc?f.height:0));var b=Ja;Eb=Math.min(Fb-1,Math.floor(a/Gb));Ja=Math.round(Eb*$b);a-=Ja;if(Ja!=b){var e=S(a);Xa(e);for(var l in ka)ka[l].m.style.top=g.rowHeight*l-Ja+"px"}Hb!=a&&(vb=Hb+b<a+Ja?1:-1,Ha[0].scrollTop=ac=Ga=Hb=a,B(T.onViewportChanged,{}))}function U(a,b){var e=(a=q.getItemMetadata&&q.getItemMetadata(a))&&a.j&&(a.j[b.id]||a.j[Sa[b.id]]);return e&&e.formatter||a&&a.formatter||b.formatter||g.formatterFactory&&g.formatterFactory.Qb(b)||g.defaultFormatter}
function ja(a,b){var e=n[b];return(a=(a=q.getItemMetadata&&q.getItemMetadata(a))&&a.j)&&a[e.id]&&void 0!==a[e.id].editor?a[e.id].editor:a&&a[b]&&void 0!==a[b].editor?a[b].editor:e.editor||g.editorFactory&&g.editorFactory.Pb(e)}function ia(a,b){return g.dataItemColumnValueExtractor?g.dataItemColumnValueExtractor(a,b):a[b.field]}function Aa(a,b,e,l,x){var A=n[e],H="slick-cell l"+e+" r"+Math.min(n.length-1,e+l-1)+(A.cssClass?" "+A.cssClass:"");b===da&&e===sa&&(H+=" active");for(var Z in Ya)Ya[Z][b]&&
Ya[Z][b][A.id]&&(H+=" "+Ya[Z][b][A.id]);a.push("<div class='"+H+"'>");x&&(H=ia(x,A),a.push(U(b,A)(b,e,H,A,x)));a.push("</div>");ka[b].N.push(e);ka[b].Z[e]=l}function Xa(a){for(var b in ka)(b=parseInt(b,10))!==da&&(b<a.top||b>a.bottom)&&Ka(b)}function Da(){ha&&hb();Ob();for(var a in ka)Ka(a)}function Ka(a){var b=ka[a];b&&(bc==b.m?(b.m.style.display="none",Pb=bc):La[0].removeChild(b.m),delete ka[a],delete ob[a],Bc--,id++)}function wa(a){var b;if(a&&a.length){var e=vb=0;for(b=a.length;e<b;e++)ha&&da===
a[e]&&hb(),Ob(),ka[a[e]]&&Ka(a[e])}}function lb(a){wa([a])}function fa(a){var b=ka[a];if(b){z(a);var e=za(a),l;for(l in b.i)if(b.i.hasOwnProperty(l)){l|=0;var x=n[l],A=b.i[l];a===da&&l===sa&&ha?ha.Na(e):A.innerHTML=e?U(a,x)(a,l,ia(e,x),x,e):""}v(a)}}function ua(){db&&(Fa=g.autoHeight?g.rowHeight*Ta():parseFloat(c.css(ta[0],"height",!0))-parseFloat(c.css(ta[0],"paddingTop",!0))-parseFloat(c.css(ta[0],"paddingBottom",!0))-parseFloat(c.css(Ab[0],"height"))-Q(Ab)-(g.showTopPanel?g.topPanelHeight+Q(Qb):
0)-(g.showHeaderRow?g.headerRowHeight+Q(eb):0),cc=Math.ceil(Fa/g.rowHeight),Oa=parseFloat(c.css(ta[0],"width",!0)),g.autoHeight||Ha.height(Fa),g.forceFitColumns&&Ea(),aa(),h(),Rb=-1,C())}function aa(){if(db){var a=Ta(),b=a+(g.leaveSpaceForNewRows?cc-1:0),e=kb,l=g.showInnerTopPanel?g.innerTopPanelHeight+Q(Ib):0,x=b*g.rowHeight+l,A=G();kb=!g.autoHeight&&x>Fa;!kb&&A>Oa&&x>Fa-f.height&&(kb=!0);hb();--a;for(var H in ka)H>=a&&Ka(H);oa&&da>a&&Ob();H=bb;x>Fa-f.height?(bb=g.rowHeight*b,ab=x):bb=ab=Fa-f.height-
l;ab<k?(Gb=ab,Fb=1,$b=0):(bb=k,Gb=bb/100,Fb=Math.floor(ab/Gb),$b=(ab-bb)/(Fb-1));bb!==H&&(La.css("height",bb),Ga=Ha[0].scrollTop);b=Ga+Ja<=ab-Fa;0==ab||0==Ga?Eb=Ja=0:b?L(Ga+Ja):L(ab-Fa);bb!=H&&g.autoHeight&&ua();g.forceFitColumns&&e!=kb&&Ea();J(!1)}}function S(a,b){null==a&&(a=Ga);null==b&&(b=Ua);return{top:Wa(a),bottom:Wa(a+Fa)+1,A:b,C:b+Oa}}function t(a,b){a=S(a,b);b=Math.round(Fa/g.rowHeight);-1==vb?(a.top-=b,a.bottom+=3):1==vb?(a.top-=3,a.bottom+=b):(a.top-=3,a.bottom+=3);a.top=Math.max(0,a.top);
a.bottom=Math.min(Ta()-1,a.bottom);a.A-=Oa;a.C+=Oa;a.A=Math.max(0,a.A);a.C=Math.min(gb,a.C);return a}function z(a){if((a=ka[a])&&a.N.length)for(var b=a.m.lastChild;a.N.length;){var e=a.N.pop();a.i[e]=b;b=b.previousSibling}}function m(){g.enableAsyncPostRender&&(clearTimeout(Cc),Cc=setTimeout(p,g.asyncPostRenderDelay))}function v(a){delete ob[a];Sb=Math.min(Sb,a);Tb=Math.max(Tb,a);m()}function C(){if(db&&!Dc){var a=S(),b=t();Xa(b);if(Rb!=Ua){for(var e,l=[],x=[],A,H,Z=b.top,ca=b.bottom;Z<=ca;Z++)if(e=
ka[Z]){z(Z);var X=void 0;var pa=b;A=Z;var na=ka[A],ea=[];for(X in na.i)na.i.hasOwnProperty(X)&&(X|=0,H=na.Z[X],(Cb[X]>pa.C||Db[Math.min(n.length-1,X+H-1)]<pa.A)&&(A!=da||X!=sa)&&ea.push(X));for(;null!=(X=ea.pop());)na.m.removeChild(na.i[X]),delete na.Z[X],delete na.i[X],ob[A]&&delete ob[A][X];A=0;na=(na=q.getItemMetadata&&q.getItemMetadata(Z))&&na.j;ea=za(Z);X=0;for(pa=n.length;X<pa&&!(Cb[X]>b.C);X++)null==(H=e.Z[X])&&(H=1,na&&(H=(H=na[n[X].id]||na[X])&&H.Ha||1,"*"===H&&(H=pa-X)),Db[Math.min(pa-1,
X+H-1)]>b.A&&(Aa(l,Z,X,H,ea),A++)),X+=1<H?H-1:0;A&&x.push(Z)}if(l.length)for(Z=document.createElement("div"),Z.innerHTML=l.join("");null!=(e=x.pop());)for(e=ka[e];null!=(ca=e.N.pop());)l=Z.lastChild,e.m.appendChild(l),e.i[ca]=l}x=La[0];e=[];l=[];Z=!1;na=ya();ca=b.top;for(A=b.bottom;ca<=A;ca++)if(!ka[ca]){Bc++;l.push(ca);ka[ca]={m:null,Z:[],i:[],N:[]};ea=e;X=ca;pa=b;var Na=na;H=za(X);var Ma="slick-row"+(X<Na&&!H?" loading":"")+(X===da?" active":"")+(1==X%2?" odd":" even");H||(Ma+=" "+g.addNewRowCssClass);
(Na=q.getItemMetadata&&q.getItemMetadata(X))&&Na.kb&&(Ma+=" "+Na.kb);ea.push("<div class='ui-widget-content "+Ma+"' style='top:"+(g.rowHeight*X-Ja)+"px'>");Ma=0;for(var Nb=n.length;Ma<Nb;Ma++){var Ec=n[Ma];var wb=1;Na&&Na.j&&(wb=(Ec=Na.j[Ec.id]||Na.j[Ma])&&Ec.Ha||1,"*"===wb&&(wb=Nb-Ma));if(Db[Math.min(Nb-1,Ma+wb-1)]>pa.A){if(Cb[Ma]>pa.C)break;Aa(ea,X,Ma,wb,H)}1<wb&&(Ma+=wb-1)}ea.push("</div>");oa&&da===ca&&(Z=!0);jd++}if(l.length){b=document.createElement("div");b.innerHTML=e.join("");ca=0;for(A=
l.length;ca<A;ca++)ka[l[ca]].m=x.appendChild(b.firstChild);Z&&(oa=Za(da,sa))}Sb=a.top;Tb=Math.min(Ta()-1,a.bottom);m();ac=Ga;Rb=Ua;dc=null}}function d(){var a=eb[0].scrollLeft;a!=Ha[0].scrollLeft&&(Ha[0].scrollLeft=a)}function h(){Ga=Ha[0].scrollTop;Ua=Ha[0].scrollLeft;var a=Math.abs(Ga-Hb),b=Math.abs(Ua-kd);b&&(kd=Ua,Ab[0].scrollLeft=Ua,Qb[0].scrollLeft=Ua,eb[0].scrollLeft=Ua);if(a)if(vb=Hb<Ga?1:-1,Hb=Ga,a<Fa)L(Ga+Ja);else{var e=Ja;Eb=bb==Fa?0:Math.min(Fb-1,Math.floor((ab-Fa)/(bb-Fa)*Ga*(1/Gb)));
Ja=Math.round(Eb*$b);e!=Ja&&Da()}if(b||a)if(dc&&clearTimeout(dc),20<Math.abs(ac-Ga)||20<Math.abs(Rb-Ua))g.forceSyncScrolling||Math.abs(ac-Ga)<Fa&&Math.abs(Rb-Ua)<Oa?C():dc=setTimeout(C,50),B(T.onViewportChanged,{});B(T.onScroll,{scrollLeft:Ua,scrollTop:Ga})}function p(){for(var a=ya();Sb<=Tb;){var b=0<=vb?Sb++:Tb--,e=ka[b];if(e&&!(b>=a)){ob[b]||(ob[b]={});z(b);for(var l in e.i)if(e.i.hasOwnProperty(l)&&(l|=0,a=n[l],a.ib&&!ob[b][l])){var x=e.i[l];x&&a.ib(x,b,za(b),a);ob[b][l]=!0}Cc=setTimeout(p,g.asyncPostRenderDelay);
break}}}function I(a,b){var e,l,x;for(x in ka){var A=b&&b[x];var H=a&&a[x];if(A)for(l in A)H&&A[l]==H[l]||(e=Za(x,Sa[l]))&&c(e).removeClass(A[l]);if(H)for(l in H)A&&A[l]==H[l]||(e=Za(x,Sa[l]))&&c(e).addClass(H[l])}}function y(a,b){var e=Ya[a];Ya[a]=b;I(b,e);B(T.onCellCssStylesChanged,{key:a,hash:b})}function F(a){a=c(a.target).closest(".slick-row")[0];a!=bc&&(Pb&&Pb!=a&&(La[0].removeChild(Pb),Pb=null),bc=a)}function P(a,b){var e=Ub(a);if(!e||!Fc(e.row,e.cell))return!1;b=B(T.onDragInit,b,a);return a.isImmediatePropagationStopped()?
b:!1}function R(a,b){var e=Ub(a);if(!e||!Fc(e.row,e.cell))return!1;b=B(T.onDragStart,b,a);return a.isImmediatePropagationStopped()?b:!1}function la(a,b){return B(T.onDrag,b,a)}function ma(a,b){B(T.onDragEnd,b,a)}function fb(a){B(T.onKeyDown,{row:da,cell:sa},a);var b=a.isImmediatePropagationStopped();if(!b)if(a.shiftKey||a.altKey||a.ctrlKey)9!=a.which||!a.shiftKey||a.ctrlKey||a.altKey||((e=Zb())&&e.length?Vb(e[0],!1):b=td());else if(27==a.which){if(!W().isActive())return;ld()}else if(34==a.which)md(),
b=!0;else if(33==a.which)nd(),b=!0;else if(37==a.which)b=od();else if(39==a.which)b=pd();else if(38==a.which)b=qd();else if(40==a.which)b=ec();else if(9==a.which){var e=Zb();e&&e.length?Vb(e[0],!1):b=rd()}else if(13==a.which){if(g.editable)ha?da===ya()?ec():sd():W().commitCurrentEdit()&&fc();else if(b=Gc())e=new Slick.EventData,e.target=oa,B(T.onFocusTrigger,{row:b.row,cell:b.cell},e);b=!0}if(b){a.stopPropagation();a.preventDefault();try{a.originalEvent.keyCode=0}catch(l){}}}function te(a){ha||(a.target!=
document.activeElement||c(a.target).hasClass("slick-cell"))&&xb();var b=Ub(a);!b||null!==ha&&da==b.row&&sa==b.cell||(B(T.onClick,{row:b.row,cell:b.cell},a),a.isImmediatePropagationStopped()||sa==b.cell&&da==b.row||!ib(b.row,b.cell)||W().isActive()&&!W().commitCurrentEdit()||(Vb(b.row,!1),yb(Za(b.row,b.cell))))}function ve(a){var b=c(a.target).closest(".slick-cell",La);0===b.length||oa===b[0]&&null!==ha||B(T.onContextMenu,{},a)}function ue(a){var b=Ub(a);!b||null!==ha&&da==b.row&&sa==b.cell||(B(T.onDblClick,
{row:b.row,cell:b.cell},a),a.isImmediatePropagationStopped()||g.editable&&ud(b.row,b.cell,!0))}function re(a){B(T.onHeaderMouseEnter,{column:c(this).data("column")},a)}function se(a){B(T.onHeaderMouseLeave,{column:c(this).data("column")},a)}function pe(a){var b=c(a.target).closest(".slick-header-column",".slick-header-columns");b=b&&b.data("column");B(T.onHeaderContextMenu,{column:b},a)}function qe(a){var b=c(a.target).closest(".slick-header-column",".slick-header-columns");(b=b&&b.data("column"))&&
B(T.onHeaderClick,{column:b},a)}function we(a){B(T.onMouseEnter,{},a)}function xe(a){B(T.onMouseLeave,{},a)}function Fc(a,b){return!(0>a||a>=ya()||0>b||b>=n.length)}function Hc(a){var b=/l\d+/.exec(a.className);if(!b)throw"getCellFromNode: cannot get cell - "+a.className;return parseInt(b[0].substr(1,b[0].length-1),10)}function Ic(a){for(var b in ka)if(ka[b].m===a)return b|0;return null}function Ub(a){var b=c(a.target).closest(".slick-cell",La);if(!b.length)return null;a=Ic(b[0].parentNode);b=Hc(b[0]);
return null==a||null==b?null:{row:a,cell:b}}function Ob(){yb(null,!1)}function xb(){-1==vd?Yb[0].focus():tc[0].focus()}function gc(a,b,e){Vb(a,e);e=Jb(a,b);a=Cb[b];b=Db[b+(1<e?e-1:0)];e=Ua+Oa;a<Ua?(Ha.scrollLeft(a),h(),C()):b>e&&(Ha.scrollLeft(Math.min(a,b-Ha[0].clientWidth)),h(),C())}function yb(a,b){null!==oa&&(hb(),c(oa).removeClass("active"),ka[da]&&c(ka[da].m).removeClass("active"));var e=oa!==a;oa=a;null!=oa?(da=Ic(oa.parentNode),sa=Kb=Hc(oa),null==b&&(b=da==ya()||g.autoEdit),c(oa).addClass("active"),
c(ka[da].m).addClass("active"),g.editable&&b&&wd(da,sa)&&(clearTimeout(Jc),g.asyncEditorLoading?Jc=setTimeout(function(){fc()},g.asyncEditorLoadDelay):fc())):da=sa=null;e&&B(T.onActiveCellChanged,Gc())}function wd(a,b){var e=ya();return a<e&&!za(a)||n[b].Jb&&a>=e||!ja(a,b)?!1:!0}function hb(){if(ha){B(T.ub,{editor:ha});ha.destroy();ha=null;if(oa){var a=za(da);c(oa).removeClass("editable invalid");if(a){var b=n[sa],e=U(da,b);oa.innerHTML=e(da,sa,ia(a,b),b,a);v(da)}}if(navigator.userAgent.toLowerCase().match(/msie/))if(document.selection&&
document.selection.empty)try{document.selection.empty()}catch(l){}else window.getSelection&&(a=window.getSelection())&&a.removeAllRanges&&a.removeAllRanges();W().deactivate(hc)}}function fc(a){if(oa){if(!g.editable)throw"Grid : makeActiveCellEditable : should never get called when options.editable is false";clearTimeout(Jc);if(wd(da,sa)){var b=n[sa],e=za(da);!1===B(T.onBeforeEditCell,{row:da,cell:sa,item:e,column:b})?xb():(W().activate(hc),c(oa).addClass("editable"),a||(oa.innerHTML=""),ha=new (a||
ja(da,sa))({grid:T,Ub:ic(ta[0]),position:ic(oa),Mb:oa,column:b,item:e||{},Lb:sd,Ib:ld}),e&&ha.Na(e),xd=ha.Ra(),ha.position&&fd())}}}function sd(){W().commitCurrentEdit()&&(xb(),g.autoEdit&&ec())}function ld(){W().cancelCurrentEdit()&&xb()}function ic(a){var b={top:a.offsetTop,left:a.offsetLeft,bottom:0,right:0,width:c(a).outerWidth(),height:c(a).outerHeight(),visible:!0};b.bottom=b.top+b.height;b.right=b.left+b.width;for(var e=a.offsetParent;(a=a.parentNode)!=document.body;)b.visible&&a.scrollHeight!=
a.offsetHeight&&"visible"!=c(a).css("overflowY")&&(b.visible=b.bottom>a.scrollTop&&b.top<a.scrollTop+a.clientHeight),b.visible&&a.scrollWidth!=a.offsetWidth&&"visible"!=c(a).css("overflowX")&&(b.visible=b.right>a.scrollLeft&&b.left<a.scrollLeft+a.clientWidth),b.left-=a.scrollLeft,b.top-=a.scrollTop,a===e&&(b.left+=a.offsetLeft,b.top+=a.offsetTop,e=a.offsetParent),b.bottom=b.top+b.height,b.right=b.left+b.width;return b}function yd(){return ic(oa)}function fd(){if(oa&&(B(T.onActiveCellPositionChanged,
{}),ha)){var a=yd();ha.show&&ha.hide&&(a.visible?ha.show():ha.hide());ha.position&&ha.position(a)}}function Gc(){return oa?{row:da,cell:sa}:null}function Vb(a,b){var e=a*g.rowHeight,l=(a+1)*g.rowHeight-Fa+(uc?f.height:0);(a+1)*g.rowHeight>Ga+Fa+Ja?(L(b?e:l),C()):a*g.rowHeight<Ga+Ja&&(L(b?l:e),C())}function zd(a){a*=cc;L((Wa(Ga)+a)*g.rowHeight);C();if(g.enableCellNavigation&&null!=da){a=da+a;var b=Ta();a>=b&&(a=b-1);0>a&&(a=0);b=0;for(var e=null,l=Kb;b<=Kb;)ib(a,b)&&(e=b),b+=Jb(a,b);null!==e?(yb(Za(a,
e)),Kb=l):Ob()}}function md(){zd(1)}function nd(){zd(-1)}function Jb(a,b){a=q.getItemMetadata&&q.getItemMetadata(a);if(!a||!a.j)return 1;a=(a=a.j[n[b].id]||a.j[b])&&a.Ha;return a="*"===a?n.length-b:a||1}function Ad(a,b){if(b>=n.length)return null;do b+=Jb(a,b);while(b<n.length&&!ib(a,b));return b<n.length?{row:a,cell:b,B:b}:null}function ye(a,b){if(0>=b)return null;var e;a:{for(e=0;e<n.length;){if(ib(a,e))break a;e+=Jb(a,e)}e=null}if(null===e||e>=b)return null;for(a={row:a,cell:e,B:e};;){e=Ad(a.row,
a.cell,a.B);if(!e)return null;if(e.cell>=b)return a;a=e}}function ze(a,b,e){for(var l,x=Ta();;){if(++a>=x)return null;for(l=b=0;b<=e;)l=b,b+=Jb(a,b);if(ib(a,l))return{row:a,cell:l,B:e}}}function Ae(a,b,e){for(var l;;){if(0>--a)return null;for(l=b=0;b<=e;)l=b,b+=Jb(a,b);if(ib(a,l))return{row:a,cell:l,B:e}}}function Be(a,b){return null==a&&null==b&&(a=b=0,ib(a,b))?{row:a,cell:b,B:b}:null}function Ce(a,b){return null==a&&null==b&&(a=Ta()-1,b=n.length-1,ib(a,b))?{row:a,cell:b,B:b}:null}function pd(){return Lb("right")}
function od(){return Lb("left")}function ec(){return Lb("down")}function qd(){return Lb("up")}function rd(){return Lb("next")}function td(){return Lb("prev")}function Lb(a){if(!g.enableCellNavigation||!oa&&"prev"!=a&&"next"!=a)return!1;if(!W().commitCurrentEdit())return!0;xb();vd={up:-1,down:1,left:-1,right:1,prev:-1,next:1}[a];if(a=(0,{up:Ae,down:ze,left:ye,right:Ad,prev:Ce,next:Be}[a])(da,sa,Kb)){var b=a.row==ya();gc(a.row,a.cell,!b);yb(Za(a.row,a.cell));Kb=a.B;return!0}yb(Za(da,sa));return!1}function Za(a,
b){return ka[a]?(z(a),ka[a].i[b]):null}function ib(a,b){return!g.enableCellNavigation||a>=Ta()||0>a||b>=n.length||0>b||n[b]._noactive?!1:(a=q.getItemMetadata&&q.getItemMetadata(a))&&"boolean"===typeof a.focusable?a.focusable:(a=a&&a.j)&&a[n[b].id]&&"boolean"===typeof a[n[b].id].focusable?a[n[b].id].focusable:a&&a[b]&&"boolean"===typeof a[b].focusable?a[b].focusable:n[b].focusable}function hd(a,b){return a>=ya()||0>a||b>=n.length||0>b?!1:(a=q.getItemMetadata&&q.getItemMetadata(a))&&"boolean"===typeof a.selectable?
a.selectable:(a=a&&a.j&&(a.j[n[b].id]||a.j[b]))&&"boolean"===typeof a.selectable?a.selectable:n[b].selectable}function ud(a,b,e){db&&ib(a,b)&&W().commitCurrentEdit()&&(gc(a,b,!1),b=Za(a,b),yb(b,e||a===ya()||g.autoEdit),ha||xb())}function De(){var a=za(da),b=n[sa];if(ha){if(ha.Xb()){var e=ha.validate();if(e.valid)return da<ya()?(e={row:da,cell:sa,editor:ha,zb:ha.Ra(),yb:xd,ob:function(){this.editor.Fa(a,this.zb);fa(this.row);B(T.onCellChange,{row:da,cell:sa,item:a})},cc:function(){this.editor.Fa(a,
this.yb);fa(this.row);B(T.onCellChange,{row:da,cell:sa,item:a})}},g.mb?(hb(),g.mb(a,b,e)):(e.ob(),hb())):(e={},ha.Fa(e,ha.Ra()),hb(),B(T.onAddNewRow,{item:e,column:b})),!W().isActive();c(oa).removeClass("invalid");c(oa).width();c(oa).addClass("invalid");B(T.xb,{editor:ha,Kb:oa,dc:e,row:da,cell:sa,column:b});ha.focus();return!1}hb()}return!0}function Ee(){hb();return!0}function Zb(){if(!cb)throw"Selection model is not set";return zc}var Fe={explicitInitialization:!1,rowHeight:25,defaultColumnWidth:80,
enableAddRow:!1,leaveSpaceForNewRows:!1,editable:!1,autoEdit:!0,enableCellNavigation:!0,enableColumnReorder:!0,asyncEditorLoading:!1,asyncEditorLoadDelay:100,forceFitColumns:!1,enableAsyncPostRender:!1,asyncPostRenderDelay:50,autoHeight:!1,editorLock:Slick.GlobalEditorLock,showHeaderRow:!1,headerRowHeight:25,showTopPanel:!1,topPanelHeight:25,showInnerTopPanel:!1,innerTopPanelHeight:25,formatterFactory:null,editorFactory:null,cellFlashingCssClass:"flashing",selectedCellCssClass:"selected",multiSelect:!0,
enableTextSelectionOnCells:!1,dataItemColumnValueExtractor:null,fullWidthRows:!1,multiColumnSort:!1,defaultFormatter:function(a,b,e){return null==e?"":(e+"").replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")},forceSyncScrolling:!1,addNewRowCssClass:"new-row"},Ac={name:"",resizable:!0,sortable:!1,minWidth:30,rerenderOnResize:!1,headerCssClass:null,defaultSortAsc:!0,focusable:!0,selectable:!0},ab,bb,Gb,Fb,$b,Eb=0,Ja=0,vb=1,db=!1,ta,Qa="slickgrid_"+Math.round(1E6*Math.random()),T=this,
Yb,tc,Ab,Ca,rb,eb,ed,Qb,Ha,Ib,La,tb,Bb,ub,xc,yc,Fa,Oa,gb,uc,kb,sb=0,gd=0,vc=0,wc=0,nb,vd=1,Kb,da,sa,oa=null,ha=null,xd,hc,ka={},Bc=0,cc,Hb=0,Ga=0,ac=0,Rb=0,kd=0,Ua=0,cb,zc=[],mb=[],Ya={},Sa={},Ra=[],Cb=[],Db=[],Jc=null,dc=null,Cc=null,ob={},Tb=null,Sb=null,jd=0,id=0,bc,Pb,Dc=!1;this.debug=function(){var a="\ncounter_rows_rendered:  "+jd;a+="\ncounter_rows_removed:  "+id;a+="\nrenderedRows:  "+Bc;a+="\nnumVisibleRows:  "+cc;a+="\nmaxSupportedCssHeight:  "+k;a+="\nn(umber of pages):  "+Fb;a+="\n(current) page:  "+
Eb;a+="\npage height (ph):  "+Gb;a+="\nvScrollDir:  "+vb;alert(a)};c.extend(this,{slickGridVersion:"2.1",onScroll:new Slick.Event,onSort:new Slick.Event,onHeaderMouseEnter:new Slick.Event,onHeaderMouseLeave:new Slick.Event,onHeaderContextMenu:new Slick.Event,onHeaderClick:new Slick.Event,Pa:new Slick.Event,Oa:new Slick.Event,wb:new Slick.Event,vb:new Slick.Event,onMouseEnter:new Slick.Event,onMouseLeave:new Slick.Event,onClick:new Slick.Event,onFocusTrigger:new Slick.Event,onDblClick:new Slick.Event,
onContextMenu:new Slick.Event,onKeyDown:new Slick.Event,onAddNewRow:new Slick.Event,xb:new Slick.Event,onViewportChanged:new Slick.Event,onColumnsReordered:new Slick.Event,onColumnsResized:new Slick.Event,onCellChange:new Slick.Event,onBeforeEditCell:new Slick.Event,ub:new Slick.Event,onBeforeDestroy:new Slick.Event,onActiveCellChanged:new Slick.Event,onActiveCellPositionChanged:new Slick.Event,onDragInit:new Slick.Event,onDragStart:new Slick.Event,onDrag:new Slick.Event,onDragEnd:new Slick.Event,
onSelectedRowsChanged:new Slick.Event,onCellCssStylesChanged:new Slick.Event,registerPlugin:function(a){mb.unshift(a);a.init(T)},unregisterPlugin:r,getColumns:function(){return n},setColumns:Va,getColumnIndex:function(a){return Sa[a]},updateColumnHeader:function(a,b,e){if(db&&(a=Sa[a],null!=a)){var l=n[a],x=Ca.children().eq(a);x&&(void 0!==b&&(n[a].name=b),void 0!==e&&(n[a].toolTip=e),B(T.Oa,{node:x[0],column:l}),x.attr("title",e||"").children().eq(0).html(b),B(T.Pa,{node:x[0],column:l}))}},setSortColumn:function(a,
b){xa([{columnId:a,sortAsc:b}])},setSortColumns:xa,getSortColumns:function(){return Ra},autosizeColumns:Ea,getOptions:function(){return g},setOptions:function(a){W().commitCurrentEdit()&&(hb(),g.enableAddRow!==a.enableAddRow&&lb(ya()),g=c.extend(g,a),g.autoHeight&&(g.leaveSpaceForNewRows=!1),Ha.css("overflow-y",g.autoHeight?"hidden":"auto"),C())},getData:function(){return q},getDataLength:ya,getDataItem:za,setData:function(a,b){q=a;Da();aa();b&&L(0)},getSelectionModel:function(){return cb},setSelectionModel:function(a){cb&&
(cb.onSelectedRangesChanged.unsubscribe(ra),cb.destroy&&cb.destroy());if(cb=a)cb.init(T),cb.onSelectedRangesChanged.subscribe(ra)},getSelectedRows:Zb,setSelectedRows:function(a){if(!cb)throw"Selection model is not set";for(var b=cb,e=b.setSelectedRanges,l=[],x=n.length-1,A=0;A<a.length;A++)l.push(new Slick.Range(a[A],0,a[A],x));e.call(b,l)},getContainerNode:function(){return ta.get(0)},render:C,invalidate:function(){aa();Da();C()},invalidateRow:lb,invalidateRows:wa,invalidateAllRows:Da,updateCell:function(a,
b){var e=Za(a,b);if(e){var l=n[b],x=za(a);ha&&da===a&&sa===b?ha.Na(x):(e.innerHTML=x?U(a,l)(a,b,ia(x,l),l,x):"",v(a))}},updateRow:fa,getViewport:S,getRenderedRange:t,resizeCanvas:ua,updateRowCount:aa,scrollRowIntoView:Vb,scrollRowToTop:function(a){L(a*g.rowHeight);C()},scrollCellIntoView:gc,getCanvasNode:function(){return La[0]},focus:xb,getCellFromPoint:function(a,b){b=Wa(b);for(var e=0,l=0,x=0;x<n.length&&l<a;x++)l+=n[x].width,e++;0>e&&(e=0);return{row:b,cell:e-1}},getCellFromEvent:Ub,getActiveCell:Gc,
setActiveCell:function(a,b){!db||a>ya()||0>a||b>=n.length||0>b||!g.enableCellNavigation||(gc(a,b,!1),yb(Za(a,b),!1))},getActiveCellNode:function(){return oa},getActiveCellPosition:yd,resetActiveCell:Ob,editActiveCell:fc,getCellEditor:function(){return ha},getCellNode:Za,getCellNodeBox:function(a,b){if(!Fc(a,b))return null;a=g.rowHeight*a-Ja;for(var e=a+g.rowHeight-1,l=0,x=0;x<b;x++)l+=n[x].width;return{top:a,left:l,bottom:e,right:l+n[b].width}},canCellBeSelected:hd,canCellBeActive:ib,navigatePrev:td,
navigateNext:rd,navigateUp:qd,navigateDown:ec,navigateLeft:od,navigateRight:pd,navigatePageUp:nd,navigatePageDown:md,gotoCell:ud,getInnerTopPanel:function(){return Ib[0]},setInnerTopPanelVisibility:function(a){g.showInnerTopPanel!=a&&((g.showInnerTopPanel=a)?Ib.slideDown("fast",ua):Ib.slideUp("fast",ua))},setHeaderRowVisibility:function(a){g.showHeaderRow!=a&&((g.showHeaderRow=a)?eb.slideDown("fast",ua):eb.slideUp("fast",ua))},getHeaderRow:function(){return rb[0]},getHeaderRowColumn:function(a){a=
Sa[a];return(a=rb.children().eq(a))&&a[0]},getGridPosition:function(){return ic(ta[0])},flashCell:function(a,b,e){function l(A){A&&setTimeout(function(){x.queue(function(){x.toggleClass(g.cellFlashingCssClass).dequeue();l(A-1)})},e)}e=e||100;if(ka[a]){var x=c(Za(a,b));l(4)}},addCellCssStyles:function(a,b){if(Ya[a])throw"addCellCssStyles: cell CSS hash with key '"+a+"' already exists.";Ya[a]=b;I(b,null);B(T.onCellCssStylesChanged,{key:a,hash:b})},setCellCssStyles:y,removeCellCssStyles:function(a){Ya[a]&&
(I(null,Ya[a]),delete Ya[a],B(T.onCellCssStylesChanged,{key:a,hash:null}))},getCellCssStyles:function(a){return Ya[a]},init:w,destroy:function(){W().cancelCurrentEdit();B(T.onBeforeDestroy,{});for(var a=mb.length;a--;)r(mb[a]);g.enableColumnReorder&&Ca.filter(":ui-sortable").sortable("destroy");Bb&&(Bb.unbind("scroll."+Qa),Bb=null);ta.unbind(".slickgrid");tb.remove();ub=null;La.unbind("draginit dragstart dragend drag");ta.empty().removeClass(Qa)},getEditorLock:W,getEditController:function(){return hc},
measureCellPaddingAndBorder:V,beginRender:function(){Dc=!0},endRender:function(a){Dc=!1;0!=a&&C()},onColumnResizerDblClick:new Slick.Event,enableColumnFit:function(){function a(e){var l=e.cloneNode(!0);l.style.cssText="position: absolute; right: auto;text-overflow: initial;white-space: nowrap; visibility: hidden;";e.parentNode.insertBefore(l,e);e=l.offsetWidth;l.parentNode.removeChild(l);return e}var b=document.createElement("canvas").getContext("2d");T.onColumnResizerDblClick.subscribe(function(e,
l){if((e=l.column)&&1!=e._nofit){l=Sa[e.id];var x=Ca.children()[l];x=x?a(x)+8:0;for(var A=0,H=S(),Z=H.top,ca=H.top;ca<H.bottom;++ca)if(ka[ca]){z(ca);var X=ka[ca].i[l];X=X?b.measureText(X.textContent||"").width:0;X>A&&(A=X,Z=ca)}l=ka[Z]?1+a(ka[Z].i[l]):0;l=Math.max(x,l);0<l&&l!=e.width&&(e.width=l,Ba(),J(!0),B(T.onColumnsResized,{}))}})},getRowNode:function(a){return ka[a]?ka[a].m:null},getCellNodeFromEvent:function(a){a=c(a.target).closest(".slick-cell",La);if(!a.length)return null;var b=Ic(a[0].parentNode),
e=Hc(a[0]);return null==b||null==e?null:{row:b,cell:e,$cell:a}}});(function(){ta=c(u);if(1>ta.length)throw Error("SlickGrid requires a valid container, "+u+" does not exist in the DOM.");var a;if(!(a=k)){a=1E6;for(var b=navigator.userAgent.toLowerCase().match(/firefox/)?6E6:1E9,e=c("<div style='display:none' />").appendTo(document.body);;){var l=2*a;e.css("height",l);if(l>b||e.height()!==l)break;else a=l}e.remove()}k=a;(a=f)||(a=c("<div style='position:absolute; top:-10000px; left:-10000px; width:100px; height:100px; overflow:scroll;'></div>").appendTo("body"),
b={width:a.width()-a[0].clientWidth,height:a.height()-a[0].clientHeight},a.remove(),a=b);f=a;g=c.extend({},Fe,g);g.autoHeight&&(g.leaveSpaceForNewRows=!1);Ac.width=g.defaultColumnWidth;Sa={};for(a=0;a<n.length;a++)b=n[a]=c.extend({},Ac,n[a]),Sa[b.id]=a,b.minWidth&&b.width<b.minWidth&&(b.width=b.minWidth),b.maxWidth&&b.width>b.maxWidth&&(b.width=b.maxWidth);if(g.enableColumnReorder&&!c.fn.sortable)throw Error("SlickGrid's 'enableColumnReorder = true' option requires jquery-ui.sortable module to be loaded");
hc={commitCurrentEdit:De,cancelCurrentEdit:Ee};ta.empty().css("overflow","hidden").css("outline",0).addClass(Qa).addClass("ui-widget");/relative|absolute|fixed/.test(ta.css("position"))||ta.css("position","relative");Yb=c("<div tabIndex='0' hideFocus style='position:fixed;width:0;height:0;top:0;left:0;outline:0;'></div>").appendTo(ta);Ab=c("<div class='slick-header ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);Ca=c("<div class='slick-header-columns' style='left:-1000px' />").appendTo(Ab);
Ca.width(E());eb=c("<div class='slick-headerrow ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);rb=c("<div class='slick-headerrow-columns' />").appendTo(eb);ed=c("<div style='display:block;height:1px;position:absolute;top:0;left:0;'></div>").css("width",G()+f.width+"px").appendTo(eb);Qb=c("<div class='slick-top-panel-scroller ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);c("<div class='slick-top-panel' style='width:10000px' />").appendTo(Qb);
g.showTopPanel||Qb.hide();g.showHeaderRow||eb.hide();Ha=c("<div class='slick-viewport' style='width:100%;overflow:auto;outline:0;position:relative;;'>").appendTo(ta);Ha.css("overflow-y",g.autoHeight?"hidden":"auto");La=c("<div class='grid-canvas' />").appendTo(Ha);Ib=c("<div class='grid-inner-top-panel'/>").appendTo(Ha);g.showInnerTopPanel||Ib.hide();tc=Yb.clone().appendTo(ta);g.explicitInitialization||w()})()}}});var f,k})(jQuery);
(function(c){c.extend(!0,window,{Slick:{Data:{DataView:function(f){function k(){return!0}function u(d){for(var h=d||0,p=D.length;h<p;h++){d=D[h][Ba];if(void 0===d)throw"Each data element must implement a unique 'id' property";ra[d]=h}}function q(){return{pageSize:S,pageNum:t,totalRows:z,totalPages:S?Math.max(1,Math.ceil(z/S)):1}}function n(d,h){za=h;L=d;Wa=null;if(d){!1===h&&D.reverse();for(var p=0,I=D.length;p<I;++p)D[p].index=p;D.sort(d);!1===h&&D.reverse();ra={};u();W()}}function g(d,h){za=h;Wa=
d;L=null;var p=Object.prototype.toString;Object.prototype.toString="function"==typeof d?d:function(){return this[d]};!1===h&&D.reverse();D.sort();Object.prototype.toString=p;!1===h&&D.reverse();ra={};u();W()}function w(d){!1===za&&d.reverse();d.sort(L);!1===za&&d.reverse();ra={};for(var h=0,p=0;h<d.length||p<D.length;++p)h<d.length&&(p==D.length||0<L(d[h],D[p])!=za)&&D.splice(p,0,d[h++]),ra[D[p].id]=p;W()}function r(d){f.groupItemMetadataProvider||(f.groupItemMetadataProvider=new Slick.Data.GroupItemMetadataProvider);
ua=[];aa=[];d=d||[];fa=d instanceof Array?d:[d];for(d=0;d<fa.length;d++){var h=fa[d]=c.extend(!0,{},lb,fa[d]);h.pb="function"===typeof h.ba;h.na=[];for(var p=h.G.length;p--;){var I=h.na,y=p,F=Ia(h.G[p].Y);F=new Function("_items","for (var "+F.H[0]+", _i=0, _il=_items.length; _i<_il; _i++) {"+F.H[0]+" = _items[_i]; "+F.body+"}");F.displayName=F.name="compiledAccumulatorLoop";I[y]=F}aa[d]={}}W()}function E(){if(!Pa){Pa={};for(var d=0,h=xa.length;d<h;d++)Pa[xa[d][Ba]]=d}}function G(d,h){if(null==d)for(d=
0;d<fa.length;d++)aa[d]={},fa[d].collapsed=h;else aa[d]={},fa[d].collapsed=h;W()}function J(d,h,p){aa[d][h]=fa[d].collapsed^p;W()}function ba(d,h){for(var p,I,y=[],F={},P,R=h?h.level+1:0,la=fa[R],ma=0,fb=la.Qa.length;ma<fb;ma++)I=la.Qa[ma],p=F[I],p||(p=new Slick.Group,p.value=I,p.level=R,p.P=(h?h.P+":|:":"")+I,y[y.length]=p,F[I]=p);ma=0;for(fb=d.length;ma<fb;ma++)P=d[ma],I=la.pb?la.ba(P):P[la.ba],p=F[I],p||(p=new Slick.Group,p.value=I,p.level=R,p.P=(h?h.P+":|:":"")+I,y[y.length]=p,F[I]=p),p.rows[p.count++]=
P;if(R<fa.length-1)for(ma=0;ma<y.length;ma++)p=y[ma],p.groups=ba(p.rows,p);y.sort(fa[R].Ia);return y}function Y(d){var h=d.group,p=fa[h.level],I=h.level==fa.length,y,F=p.G.length;if(!I&&p.Ea)for(y=h.groups.length;y--;)h.groups[y].da||Y(h.groups[y]);for(;F--;)y=p.G[F],y.init(),!I&&p.Ea?p.na[F].call(y,h.groups):p.na[F].call(y,h.rows),y.ga(d);d.da=!0}function qa(d,h){h=h||0;for(var p=fa[h],I=p.collapsed,y=aa[h],F=d.length,P;F--;)if(P=d[F],!P.collapsed||p.ma){P.groups&&qa(P.groups,h+1);if(p.G.length&&
(p.hb||P.rows.length||P.groups&&P.groups.length)){var R=P,la=fa[R.level],ma=new Slick.GroupTotals;ma.group=R;R.I=ma;la.sb||Y(ma)}P.collapsed=I^y[P.P];P.title=p.formatter?p.formatter(P):P.value}}function M(d,h){h=h||0;for(var p=fa[h],I=[],y,F=0,P,R=0,la=d.length;R<la;R++){P=d[R];I[F++]=P;if(!P.collapsed){y=P.groups?M(P.groups,h+1):P.rows;for(var ma=0,fb=y.length;ma<fb;ma++)I[F++]=y[ma]}P.I&&p.Ja&&(!P.collapsed||p.ma)&&(I[F++]=P.I)}return I}function Ia(d){d=d.toString().match(/^function[^(]*\(([^)]*)\)\s*{([\s\S]*)}$/);
return{H:d[1].split(","),body:d[2]}}function va(d,h){for(var p=[],I=0,y=0,F=d.length;y<F;y++)Va(d[y],h)&&(p[I++]=d[y]);return p}function Q(d,h,p){for(var I=[],y=0,F,P=0,R=d.length;P<R;P++)F=d[P],p[P]?I[y++]=F:Va(F,h)&&(I[y++]=F,p[P]=!0);return I}function V(d,h){for(var p=[],I=0,y,F,P,R=0,la=d.length;R<la;R++)y=d[R],F=y.M||(y.M={}),P=F[h],!(P||void 0==P&&(F[h]=Va(y,h)))||wa&&!k(y,wa)||(p[I++]=y);return p}function N(d,h,p){for(var I=[],y=0,F,P,R,la=0,ma=d.length;la<ma;la++)F=d[la],P=F.M||(F.M={}),R=
P[h],p[la]?I[y++]=F:!(R||void 0==R&&(P[h]=Va(F,h)))||wa&&!k(F,wa)||(I[y++]=F,p[la]=!0);return I}function B(d){Pa=null;if(U.Ma!=ja.Ma||U.La!=ja.La)Ka=[];if(Va){var h=f.inlineFilters?Xa:f.cacheFilters?V:va,p=f.inlineFilters?Da:f.cacheFilters?N:Q;U.Ma?Aa=h(Aa,ia):U.La?Aa=p(d,ia,Ka):U.Wb||(Aa=h(d,ia))}else Aa=S?d:d.concat();S?(Aa.length<t*S&&(t=Math.floor(Aa.length/S)),h=Aa.slice(S*t,S*t+S)):h=Aa;z=d=Aa.length;d=h;ua=[];fa.length&&(ua=ba(d),ua.length&&(qa(ua),d=M(ua)));h=xa;p=d;var I,y=[];var F=0;var P=
p.length;U&&U.rb&&(F=Math.max(0,Math.min(p.length,U.rb)));U&&U.qb&&(P=Math.min(p.length,Math.max(0,U.qb)));for(var R=F,la=h.length;R<P;R++)if(R>=la)y[y.length]=R;else{F=p[R];var ma=h[R];if(fa.length&&(I=F.Ba||ma.Ba)&&F.L!==ma.L||F.L&&!F.nb(ma)||I&&(F.X||ma.X)||F[Ba]!=ma[Ba]||ya&&ya[F[Ba]])y[y.length]=R}xa=d;return y}function W(){if(!Ta){var d=xa.length,h=z,p=B(D);S&&z<t*S&&(t=Math.max(0,Math.ceil(z/S)-1),p=B(D));ya=null;ja=U;U={};h!=z&&C.notify(q(),null,Ea);d!=xa.length&&m.notify({previous:d,current:xa.length,
diffRows:p},null,Ea);0<p.length&&v.notify({rows:p},null,Ea)}}var Ea=this,Ba="id",D=[],xa=[],ra={},Pa=null,Va=null,ya=null,Ta=!1,za=!0,Wa,L,U={},ja={},ia,Aa=[],Xa,Da,Ka=[],wa="",lb={ba:null,formatter:null,Ia:function(d,h){return d.value-h.value},Qa:[],G:[],hb:!1,ma:!1,Ea:!1,collapsed:!1,Ja:!0,sb:!1},fa=[],ua=[],aa=[],S=0,t=0,z=0,m=new Slick.Event,v=new Slick.Event,C=new Slick.Event;f=c.extend(!0,{},{groupItemMetadataProvider:null,inlineFilters:!1,cacheFilters:!1},f);c.extend(this,{beginUpdate:function(){Ta=
!0},endUpdate:function(){Ta=!1;W()},setPagingOptions:function(d){void 0!=d.pageSize&&(t=(S=d.pageSize)?Math.min(t,Math.max(0,Math.ceil(z/S)-1)):0);void 0!=d.pageNum&&(t=Math.min(d.pageNum,Math.max(0,Math.ceil(z/S)-1)));C.notify(q(),null,Ea);W()},getPagingInfo:q,getItems:function(){return D},setItems:function(d,h){void 0!==h&&(Ba=h);D=Aa=d;ra={};u();h=0;for(var p=D.length;h<p;h++)if(d=D[h][Ba],void 0===d||ra[d]!==h)throw"Each data element must implement a unique 'id' property";W()},setFilter:function(d){Va=
d;if(f.inlineFilters){d=Ia(Va);var h=d.body.replace(/return false\s*([;}]|$)/gi,"{ continue _coreloop; }$1").replace(/return true\s*([;}]|$)/gi,"{ _retval[_idx++] = $item$; continue _coreloop; }$1").replace(/return ([^;}]+?)\s*([;}]|$)/gi,"{ if ($1) { _retval[_idx++] = $item$; }; continue _coreloop; }$2");h="var _retval = [], _idx = 0; var $item$, $args$ = _args; _coreloop: for (var _i = 0, _il = _items.length; _i < _il; _i++) { $item$ = _items[_i]; $filter$; } return _retval; ".replace(/\$filter\$/gi,
h);h=h.replace(/\$item\$/gi,d.H[0]);h=h.replace(/\$args\$/gi,d.H[1]);d=new Function("_items,_args",h);d.displayName=d.name="compiledFilter";Xa=d;d=Ia(Va);h=d.body.replace(/return false\s*([;}]|$)/gi,"{ continue _coreloop; }$1").replace(/return true\s*([;}]|$)/gi,"{ _cache[_i] = true;_retval[_idx++] = $item$; continue _coreloop; }$1").replace(/return ([^;}]+?)\s*([;}]|$)/gi,"{ if ((_cache[_i] = $1)) { _retval[_idx++] = $item$; }; continue _coreloop; }$2");h="var _retval = [], _idx = 0; var $item$, $args$ = _args; _coreloop: for (var _i = 0, _il = _items.length; _i < _il; _i++) { $item$ = _items[_i]; if (_cache[_i]) { _retval[_idx++] = $item$; continue _coreloop; } $filter$; } return _retval; ".replace(/\$filter\$/gi,
h);h=h.replace(/\$item\$/gi,d.H[0]);h=h.replace(/\$args\$/gi,d.H[1]);d=new Function("_items,_args,_cache",h);d.displayName=d.name="compiledFilterWithCaching";Da=d}W()},sort:n,fastSort:g,reSort:function(){L?n(L,za):Wa&&g(Wa,za)},setGrouping:r,getGrouping:function(){return fa},groupBy:function(d,h,p){null==d?r([]):r({ba:d,formatter:h,Ia:p})},setAggregators:function(d,h){if(!fa.length)throw Error("At least one grouping must be specified before calling setAggregators().");fa[0].G=d;fa[0].ma=h;r(fa)},
collapseAllGroups:function(d){G(d,!0)},expandAllGroups:function(d){G(d,!1)},collapseGroup:function(d){var h=Array.prototype.slice.call(arguments),p=h[0];1==h.length&&-1!=p.indexOf(":|:")?J(p.split(":|:").length-1,p,!0):J(h.length-1,h.join(":|:"),!0)},expandGroup:function(d){var h=Array.prototype.slice.call(arguments),p=h[0];1==h.length&&-1!=p.indexOf(":|:")?J(p.split(":|:").length-1,p,!1):J(h.length-1,h.join(":|:"),!1)},getGroups:function(){return ua},getIdxById:function(d){return ra[d]},getRowById:function(d){E();
return Pa[d]},getItemById:function(d){return D[ra[d]]},getItemByIdx:function(d){return D[d]},mapRowsToIds:function(d){for(var h=[],p=0,I=d.length;p<I;p++)d[p]<xa.length&&(h[h.length]=xa[d[p]][Ba]);return h},mapIdsToRows:function(d){var h=[];E();for(var p=0,I=d.length;p<I;p++){var y=Pa[d[p]];null!=y&&(h[h.length]=y)}return h},setRefreshHints:function(d){U=d},setFilterArgs:function(d){ia=d},refresh:W,updateItem:function(d,h){if(void 0===ra[d]||d!==h[Ba])throw"Invalid or non-matching id";D[ra[d]]=h;
ya||(ya={});ya[d]=!0;W()},insertItem:function(d,h){D.splice(d,0,h);u(d);W()},addItem:function(d){D.push(d);u(D.length-1);W()},addItems:function(d){var h=D.length;Array.prototype.push.apply(D,d);u(h);W()},deleteItem:function(d){var h=ra[d];if(void 0===h)throw"Invalid id";delete ra[d];D.splice(h,1);u(h);W()},deleteItems:function(d){for(var h=[],p=0,I=d.length;p<I;++p){var y=ra[d[p].id];if(void 0===y)throw"Invalid id";h.push(y)}if(h.length){h.sort(function(F,P){return F-P});for(p=h.length-1;0<=p;--p)D.splice(h[p],
1);u(h[0]);W()}},syncGridSelection:function(d,h,p){function I(la){R.join(",")!=la.join(",")&&(R=la)}function y(){if(0<R.length){P=!0;var la=F.mapIdsToRows(R);h||I(F.mapRowsToIds(la));d.setSelectedRows(la);P=!1}}var F=this,P,R=F.mapRowsToIds(d.getSelectedRows());d.onSelectedRowsChanged.subscribe(function(){if(!P){var la=F.mapRowsToIds(d.getSelectedRows());if(p&&d.getOptions().multiSelect){var ma=c.grep(R,function(fb){return void 0===F.getRowById(fb)});I(ma.concat(la))}else I(la)}});this.onRowsChanged.subscribe(y);
this.onRowCountChanged.subscribe(y)},syncGridCellCssStyles:function(d,h){function p(P){y={};for(var R in P)y[xa[R][Ba]]=P[R]}function I(){if(y){F=!0;E();var P={},R;for(R in y){var la=Pa[R];void 0!=la&&(P[la]=y[R])}d.setCellCssStyles(h,P);F=!1}}var y,F;p(d.getCellCssStyles(h));d.onCellCssStylesChanged.subscribe(function(P,R){F||h==R.key&&R.hash&&p(R.hash)});this.onRowsChanged.subscribe(I);this.onRowCountChanged.subscribe(I)},getLength:function(){return xa.length},getItem:function(d){if((d=xa[d])&&
d.L&&d.I&&!d.I.da){var h=fa[d.level];h.Ja||(Y(d.I),d.title=h.formatter?h.formatter(d):d.value)}else d&&d.X&&!d.da&&Y(d);return d},getItemMetadata:function(d){d=xa[d];return void 0===d?null:d.L?f.groupItemMetadataProvider.Rb(d):d.X?f.groupItemMetadataProvider.Tb(d):null},onRowCountChanged:m,onRowsChanged:v,onPagingInfoChanged:C,setSearchText:function(d){wa=d},setSearchFunc:function(d){k=d},getSearchText:function(){return wa},invalidateFilterCache:function(d){for(var h=0;h<d.length;++h){var p=ra[d[h]];
void 0!=p&&(D[p].M={})}},mergeItemsUpdates:function(d){for(const h of d)d=ra[h.id],void 0!=d&&(d=D[d],Object.assign(d,h),d.M={},d.Eb=void 0,d.Fb=void 0)},reSortOne:function(d,h){if(L&&(d=ra[d],void 0!=d)){var p=D[d];D.splice(d,1);for(var I=0;I<D.length&&0<L(p,D[I])==za;++I);D.splice(I,0,p);I!=d?(u(Math.min(I,d)),W()):h&&W()}},reSortNew:function(d){if(L&&!(d>=D.length)){d=D.splice(d,D.length);for(var h=0;h<d.length;++h)d[h].index=h+D.length;return w(d)}},reSortUpdate:function(d){if(L&&d&&d.length){for(var h=
[],p=[],I=0;I<d.length;++I){var y=ra[d[I]];void 0!=y&&(h.push(y),p.push(D[y]))}h.sort(function(F,P){return F-P});for(I=h.length-1;0<=I;--I)D.splice(h[I],1);return w(p)}},updateIdxById:u,getRows:function(){return xa},validateIdxById:function(){for(var d=0,h=D.length;d<h;++d)ra[D[d].id]!=d&&alert("idxById invalid")}})},Aggregators:{Avg:function(f){this.o=f;this.init=function(){this.D=this.qa=0};this.Y=function(k){k=k[this.o];null!=k&&""!==k&&(this.qa++,this.D+=parseFloat(k))};this.ga=function(k){k.Ga||
(k.Ga={});0!=this.qa&&(k.Ga[this.o]=this.D/this.qa)}},Min:function(f){this.o=f;this.init=function(){this.fa=null};this.Y=function(k){k=k[this.o];null!=k&&""!==k&&(null==this.fa||k<this.fa)&&(this.fa=k)};this.ga=function(k){k.min||(k.min={});k.min[this.o]=this.fa}},Max:function(f){this.o=f;this.init=function(){this.ea=null};this.Y=function(k){k=k[this.o];null!=k&&""!==k&&(null==this.ea||k>this.ea)&&(this.ea=k)};this.ga=function(k){k.max||(k.max={});k.max[this.o]=this.ea}},Sum:function(f){this.o=f;
this.init=function(){this.D=null};this.Y=function(k){k=k[this.o];null!=k&&""!==k&&(this.D+=parseFloat(k))};this.ga=function(k){k.Sa||(k.Sa={});k.Sa[this.o]=this.D}}}}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{AutoTooltips:function(f){function k(g){if((g=q.getCellNodeFromEvent(g))&&!q.getColumns()[g.cell]._notip){g=g.$cell;f.tipHandle&&(g=g.find(f.tipHandle));var w=g[0];if(w.Ab!=w.scrollWidth){if(g.innerWidth()<w.scrollWidth){var r=c.trim(g.text());f.maxToolTipLength&&r.length>f.maxToolTipLength&&(r=r.substr(0,f.maxToolTipLength-3)+"...")}else r="";w.Ab=w.scrollWidth;g.attr("title",r)}}}function u(g,w){w=w.column;g=c(g.target).closest(".slick-header-column");w.toolTip||
g.attr("title",g.innerWidth()<g[0].scrollWidth?w.name:"")}var q,n={enableForCells:!0,enableForHeaderCells:!1,maxToolTipLength:null,tipHandle:null};c.extend(this,{init:function(g){f=c.extend(!0,{},n,f);q=g;f.enableForCells&&q.onMouseEnter.subscribe(k);f.enableForHeaderCells&&q.onHeaderMouseEnter.subscribe(u)},destroy:function(){f.enableForCells&&q.onMouseEnter.unsubscribe(k);f.enableForHeaderCells&&q.onHeaderMouseEnter.unsubscribe(u)},config:function(g,w){f[g]=w}})}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{RowSelectionModel:function(f){function k(Q){return function(){M||(M=!0,Q.apply(this,arguments),M=!1)}}function u(Q){for(var V=[],N=0;N<Q.length;N++)for(var B=Q[N].fromRow;B<=Q[N].toRow;B++)V.push(B);return V}function q(Q){for(var V=[],N=J.getColumns().length-1,B=0;B<Q.length;B++)V.push(new Slick.Range(Q[B],0,Q[B],N));return V}function n(Q,V){var N,B=[];for(N=Q;N<=V;N++)B.push(N);for(N=V;N<Q;N++)B.push(N);return B}function g(){return u(ba)}function w(Q){ba=Q;
Y.onSelectedRangesChanged.notify(ba)}function r(Q,V){Ia.selectActiveRow&&null!=V.row&&w([new Slick.Range(V.row,0,V.row,J.getColumns().length-1)])}function E(Q){var V=J.getActiveCell();if(V&&Q.shiftKey&&!Q.ctrlKey&&!Q.altKey&&!Q.metaKey&&(38==Q.which||40==Q.which)){var N=g();N.sort(function(W,Ea){return W-Ea});N.length||(N=[V.row]);var B=N[0];N=N[N.length-1];V=40==Q.which?V.row<N||B==N?++N:++B:V.row<N?--N:--B;0<=V&&V<J.getDataLength()&&(J.scrollRowIntoView(V),ba=q(n(B,N)),w(ba));Q.preventDefault();
Q.stopPropagation()}}function G(Q){var V=J.getCellFromEvent(Q);if(!(V&&J.canCellBeActive(V.row,V.cell)&&J.getOptions().multiSelect&&(Q.ctrlKey||Q.shiftKey||Q.metaKey)))return!1;var N=u(ba),B=c.inArray(V.row,N);if(-1===B&&(Q.ctrlKey||Q.metaKey))N.push(V.row),J.setActiveCell(V.row,V.cell);else if(-1!==B&&(Q.ctrlKey||Q.metaKey))N=c.grep(N,function(Ba){return Ba!==V.row}),J.setActiveCell(V.row,V.cell);else if(N.length&&Q.shiftKey){B=N.pop();var W=Math.min(V.row,B),Ea=Math.max(V.row,B);for(N=[];W<=Ea;W++)W!==
B&&N.push(W);N.push(B);J.setActiveCell(V.row,V.cell)}ba=q(N);w(ba);Q.stopImmediatePropagation();return!0}var J,ba=[],Y=this,qa=new Slick.EventHandler,M,Ia,va={selectActiveRow:!0};c.extend(this,{getSelectedRows:g,setSelectedRows:function(Q){w(q(Q))},getSelectedRanges:function(){return ba},setSelectedRanges:w,init:function(Q){Ia=c.extend(!0,{},va,f);J=Q;qa.subscribe(J.onActiveCellChanged,k(r));qa.subscribe(J.onKeyDown,k(E));qa.subscribe(J.onClick,k(G))},destroy:function(){qa.unsubscribeAll()},onSelectedRangesChanged:new Slick.Event})}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{CheckboxSelectColumn:function(f){function k(G){G?c("#cbox_all_header").prop("checked",!0):c("#cbox_all_header").prop("checked",!1)}function u(){for(var G=0,J=w.getDataLength()-1;G<=J;++G,--J)if(!w.getDataItem(G).sel||!w.getDataItem(J).sel){k(!1);return}k(!0)}function q(G,J){if(w.getColumns()[J.cell].id===E.columnId&&c(G.target).is(":checkbox")){if(w.getEditorLock().isActive()&&!w.getEditorLock().commitCurrentEdit())G.preventDefault();else{var ba=G.target.checked,
Y=1,qa=w.getSelectionModel().getSelectedRows();if(-1!=qa.indexOf(J.row)){J=Y=0;for(var M=qa.length;J<M;++J)w.getDataItem(qa[J]).sel!=ba&&(w.getDataItem(qa[J]).sel=ba,++Y);1<Y&&(w.invalidateRows(qa),w.render())}else w.getDataItem(J.row).sel=ba;c(G.target).closest(".slick-row").toggleClass("checked_row",ba);G.target.checked?u():k(!1);if(E.onCheck)E.onCheck(ba?Y:-Y);G.stopPropagation()}G.stopImmediatePropagation()}}function n(G,J){if(J.column.id==E.columnId&&c(G.target).is(":checkbox")){J=G.target.checked;
for(var ba=0,Y=w.getDataLength();ba<Y;ba++)w.getDataItem(ba).sel=J;w.invalidateAllRows();w.render();if(E.onCheckAll)E.onCheckAll(J);G.stopPropagation();G.stopImmediatePropagation()}}function g(G,J,ba,Y,qa){return qa?(setTimeout(function(){var M=w.getRowNode(G);M&&c(M).toggleClass("checked_row",ba)},0),ba?"<input type='checkbox' checked='checked'>":"<input type='checkbox'>"):null}var w,r=new Slick.EventHandler,E=c.extend(!0,{},{columnId:"_checkbox_selector",cssClass:null,width:30,onCheck:null,onCheckAll:null},
f);c.extend(this,{init:function(G){w=G;r.subscribe(w.onClick,q).subscribe(w.onHeaderClick,n)},destroy:function(){r.unsubscribeAll()},getColumnDefinition:function(){return{id:E.columnId,name:"<input id='cbox_all_header' type='checkbox'>",toolTip:E.toolTip,field:"sel",width:E.width,resizable:!1,sortable:!1,cssClass:E.cssClass,formatter:g,_noactive:!0,_nofit:!0}},initData:function(G){for(var J=0,ba=G.length;J<ba;++J)G[J].sel=!1},getCheckedRows:function(){for(var G=[],J=0,ba=w.getDataLength();J<ba;J++)1==
w.getDataItem(J).sel&&G.push(J);return G},getCheckedRowsCount:function(){for(var G=0,J=0,ba=w.getDataLength();J<ba;J++)1==w.getDataItem(J).sel&&++G;return G},setCheckedRows:function(G,J,ba){if(1==ba)for(var Y=0,qa=w.getDataLength();Y<qa;Y++)w.getDataItem(Y).sel=!1;Y=0;for(qa=G.length;Y<qa;Y++)w.getDataItem(G[Y]).sel=J;1==ba?(w.invalidateAllRows(),k(J&&G.length==w.getDataLength())):(w.invalidateRows(G),J?u():0<G.length&&k(!1));w.render()},recheckFull:u,isFullChecked:function(){return c("#cbox_all_header").prop("checked")}})}}})})(jQuery);
(function(c){c.fn.numeric=function(f,k){"boolean"===typeof f&&(f={decimal:f});f=f||{};"undefined"==typeof f.negative&&(f.negative=!0);var u=!1===f.decimal?"":f.decimal||".";f=!0===f.negative?!0:!1;k="function"==typeof k?k:function(){};return this.data("numeric.decimal",u).data("numeric.negative",f).data("numeric.callback",k).keypress(c.fn.numeric.keypress).keyup(c.fn.numeric.keyup).blur(c.fn.numeric.blur)};c.fn.numeric.keypress=function(f){var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.negative"),
q=f.charCode?f.charCode:f.keyCode?f.keyCode:0;if(13==q&&"input"==this.nodeName.toLowerCase())return!0;if(13==q)return!1;var n=!1;if(f.ctrlKey&&97==q||f.ctrlKey&&65==q||f.ctrlKey&&120==q||f.ctrlKey&&88==q||f.ctrlKey&&99==q||f.ctrlKey&&67==q||f.ctrlKey&&122==q||f.ctrlKey&&90==q||f.ctrlKey&&118==q||f.ctrlKey&&86==q||f.shiftKey&&45==q)return!0;if(48>q||57<q){var g=c(this).val();if(0!==g.indexOf("-")&&u&&45==q&&(0===g.length||0===parseInt(c.fn.Sb(this),10)))return!0;k&&q==k.charCodeAt(0)&&-1!=g.indexOf(k)&&
(n=!1);8!=q&&9!=q&&13!=q&&35!=q&&36!=q&&37!=q&&39!=q&&46!=q?n=!1:"undefined"!=typeof f.charCode&&(f.keyCode==f.which&&0!==f.which?(n=!0,46==f.which&&(n=!1)):0!==f.keyCode&&0===f.charCode&&0===f.which&&(n=!0));k&&q==k.charCodeAt(0)&&(n=-1==g.indexOf(k)?!0:!1)}else n=!0;return n};c.fn.numeric.keyup=function(){var f=c(this).val();if(f&&0<f.length){var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.negative");if(""!==k&&null!==k){var q=f.indexOf(k);0===q&&(this.value="0"+f);1==q&&"-"==f.charAt(0)&&
(this.value="-0"+f.substring(1));f=this.value}var n=[0,1,2,3,4,5,6,7,8,9,"-",k];q=f.length;for(var g=q-1;0<=g;g--){var w=f.charAt(g);0!==g&&"-"==w?f=f.substring(0,g)+f.substring(g+1):0!==g||u||"-"!=w||(f=f.substring(1));for(var r=!1,E=0;E<n.length;E++)if(w==n[E]){r=!0;break}r&&" "!=w||(f=f.substring(0,g)+f.substring(g+1))}u=f.indexOf(k);if(0<u)for(--q;q>u;q--)f.charAt(q)==k&&(f=f.substring(0,q)+f.substring(q+1));this.value=f}};c.fn.numeric.blur=function(){function f(n){if(n.max&&parseInt(n.value)>
parseInt(n.max))n.value=n.max;else if(n.min)n.value=n.min;else return;c(n).change()}var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.callback"),q=this.value;""!==q?(new RegExp("^\\d+$|^\\d*"+k+"\\d+$")).exec(q)&&this.validity.valid||(f(this),u.apply(this)):(f(this),u.apply(this))};c.fn.Yb=function(){return this.data("numeric.decimal",null).data("numeric.negative",null).data("numeric.callback",null).unbind("keypress",c.fn.numeric.keypress).unbind("blur",c.fn.numeric.blur)}})(jQuery);
globalThis.addEventListener("error",c=>{(c=ad(c.error))&&be(137,"page_referrer",c)},!0);globalThis.addEventListener("unhandledrejection",c=>{(c=ad(c.reason))&&be(138,"page_referrer",c)});var qc="",oe=-1;
(function(){function c(){function L(t){var z=N[D];return D==t.icat&&(0==z.u||-1==t.size||t.size>=z.v)}function U(t){return D==t.icat}function ja(t,z){if(!t||t.startsWith("data:"))setTimeout(function(){z(-2)},0);else{var m=new XMLHttpRequest,v=++Pa;ra[v]=m;m.open("HEAD",t,!0);m.onreadystatechange=function(){if(this.readyState==this.DONE){let C=Number(m.getResponseHeader("Content-Length"));if(isNaN(C)||!isFinite(C))C=-2;z(C)}delete ra[v]};m.onerror=function(){z(-2);console.log("Error",m.statusText);
delete ra[v]};m.send()}}function ia(t){$('[name="'+t+'"]').change(function(){if(M){var z=Mb($(this).val()),m=Q.getSelectedRows();if(m.length){for(var v=0,C=m.length;v<C;++v)M.getDataItem(m[v])[t]=z;M.beginRender();M.invalidateRows(m);z=M.getSortColumns();0<z.length&&ua[z[0].columnId]==t&&va.reSortUpdate(va.mapRowsToIds(m));M.endRender()}}})}function Aa(){var t=Q.getSelectedRows();if(0==t.length){for(t=0;t<aa.length;++t)$('[name="'+aa[t][0]+'"]').val("").removeAttr("placeholder");$(".dy_new_task_dlg input, .dy_new_task_dlg textarea, .dy_new_task_dlg select").attr("disabled",
"disabled")}else if($(".dy_new_task_dlg input, .dy_new_task_dlg textarea, .dy_new_task_dlg select").removeAttr("disabled"),1==t.length){var z=M.getDataItem(t[0]);for(t=0;t<aa.length;++t){var m=aa[t][0],v=aa[t][1];$('[name="'+m+'"]').val(z[m]).attr("placeholder",v)}}else if(1<t.length)for(t=0;t<aa.length;++t)$('[name="'+aa[t][0]+'"]').val("").attr("placeholder",K("phraseMultiValues"))}function Xa(){const t=[];if(!$(r.K).is(":checked"))for(var z=E.find(".active_exts input:checkbox:checked"),m=z.length,
v=0,C=M.getDataLength();v<C;++v)for(var d=M.getDataItem(v),h=0;h<m;++h)if(d.fext==z[h].attributes.fext.value){t.push(v);break}if(S)for(z=0,m=M.getDataLength();z<m;++z)S.test(M.getDataItem(z).url)&&t.push(z);Ia.setCheckedRows(t,!0,!0);u(D,t.length)}function Da(t,z){const m=$("[name=addtop]").prop("checked"),v=[],C=async F=>{0<v.length&&await Promise.all(v);z(F)},d=[],h={};for(var p=0,I=V.length;p<I;++p){var y=V[p];1==y.sel&&(0==N[y.icat].u||-1==y.size||y.size>=N[y.icat].v)&&(d.push({url:Mb(y.url),
naming:y.naming?(y.naming||"").trim().replace(/(^(\\|\/|\.)+)|((\\|\/|\.)+$)/g,"").replace(/\s*(\\|\/)+\s*/g,"/").trim():void 0,referer:Mb(y.referer),desc:Mb(y.desc),title:Mb(y.title),text:Mb(y.text)}),y=y.oa||"_",h[y]=(h[y]||0)+1)}d.length?(v.push(Gd(h)),chrome.tabs.sendMessage(oe,{cmd:"g_title"},function(F){jb({cmd:"new_task",add_paused:t,addtop:m,tasks:d,page_title:F||"",source:77},()=>{C&&C(!0)})}),v.push(Fd(d.length))):C&&C(!1)}function Ka(t,z,m){"size"==z?t.sort(function(v,C){if(0>v.size){if(0>
C.size){var d=v.size-C.size;return d?m?d:-d:v.index-C.index}return m?1:-1}return 0>C.size?m?-1:1:v.size-C.size||v.index-C.index},m):"sel"==z?t.sort(function(v,C){return v.sel-C.sel||v.index-C.index},m):t.sort(function(v,C){return(v[z]||"").localeCompare(C[z]||"")||v.index-C.index},m)}E=$(r.va);ba=Array(G.length);for(var wa=0,lb=G.length;wa<lb;++wa)G[wa].filter_links&&(ba[wa]=new RegExp("^("+je(wa)+")$","i"));wa=1;Y=[{id:String(wa++),name:K("fieldURL"),field:"url",sortable:!0,cssClass:"slick-cell-left",
formatter:(t,z,m,v,C)=>!Ea||Ba?m:"audio"==C.preview?'<div class="audplayer"><audio src="'+m+'"/></div>':"img"==C.preview?'<img src="'+m+'"/>':m?256<m.length?m.substr(0,256)+"...":m:""},{id:String(wa++),name:K("fieldType"),field:"fext",sortable:!0,cssClass:"slick-cell-center"},{id:String(wa++),name:K("fieldRemarks"),field:"desc",sortable:!0,cssClass:"slick-cell-center"},{id:String(wa++),name:K("fieldNaming"),field:"naming",sortable:!1,cssClass:"slick-cell-center"}];var fa={id:String(wa++),name:K("fieldFileSize"),
field:"size",sortable:!0,cssClass:"slick-cell-center",formatter:(t,z,m,v,C)=>0<=m?rc(m):-1==m?(C.gb||ja(C.url,function(d){if(J){C.size=d;if(D==C.icat){var h=va.getRowById(C.id);void 0!=h&&M.updateCell(h,3);(h=M.getSortColumns()[0])&&h.columnId==fa.id?va.reSortOne(C.id):va.refresh()}h=N[C.icat];0<d&&(h.aa.push(d),D==C.icat&&k(D));C.sel&&0<h.u&&d<h.v&&u(D,Ia.getCheckedRowsCount())}}),C.gb=!0,'<img src="/icons/sniffer/img_loading.gif"/>'):"-"},ua={};qa={explicitInitialization:!0,enableColumnReorder:!1,
forceFitColumns:!1,fullWidthRows:!0,editable:!1,autoEdit:!1};var aa=[["naming",K("phraseAutomatic")],["desc",""]],S=null;(function(){Ia=new Slick.CheckboxSelectColumn({cssClass:"slick-cell-center",onCheck:function(m){0<m?u(D,m,1):u(D,-m,-1)},onCheckAll:function(m){m?u(D,M.getDataLength()):u(D,0);$(".active_exts input:checkbox").prop("checked",m)}});Y.unshift(Ia.getColumnDefinition());for(var t=0;t<Y.length;++t)ua[Y[t].id]=Y[t].field;ua[fa.id]=fa.field;1==Ud.get("pop_showsize")&&($(r.ua).prop("checked",
!0),Y.splice(3,0,fa),$(r.F).show());1==Ud.get("pop_preview")&&($(r.V).prop("checked",!0),f(!0,!1));const z=new Slick.Data.DataView;M=new Slick.Grid(r.Grid,z,Y,qa);M.registerPlugin(new Slick.AutoTooltips({enableForHeaderCells:!0,enableForCells:!0,maxToolTipLength:256}));t=new Slick.RowSelectionModel;t.onSelectedRangesChanged.subscribe(Aa);M.setSelectionModel(t);M.registerPlugin(Ia);Q=t;M.onMouseEnter.subscribe(function(m){if(Ea&&(m=M.getCellNodeFromEvent(m))&&"url"==Y[m.cell].field){var v=m.$cell,
C=v.find("img");if(0!=C.length){var d=v.height(),h=v.width();C[0].naturalWidth<=h&&C[0].naturalHeight<=d||(C=v.outerHeight(),d=v.outerWidth(),v=v.offset(),$(r.U+" img").attr("src",M.getDataItem(m.row).url),m=$(r.U).show().height(),$(r.U).css("left",v.left+d).css("top",Math.max(0,v.top+C/2-m/2)))}}});M.onMouseLeave.subscribe(function(){Ea&&$(r.U).hide()});M.onSort.subscribe(function(m,v){Ka(z,v.sortCol.field,v.sortAsc)});M.onClick.subscribe(function(m){var v=$(m.target);v.hasClass("audplayer")&&(m=
m.target.firstChild,1!=v.data("evtattached")&&(m.addEventListener("ended",function(){this.currentTime=0;this.pause();$(this).parent().removeClass("audpause")}),v.data("evtattached",!0)),0==m.paused?(m.pause(),v.removeClass("audpause")):($("audio").each(function(){this.pause();$(this).parent().removeClass("audpause")}),m.play(),v.addClass("audpause")))});z.onRowCountChanged.subscribe(function(m,v){M.updateRowCount();v.diffRows&&v.diffRows.length||M.render()});z.onRowsChanged.subscribe(function(m,v){M.invalidateRows(v.rows);
M.render()});z.syncGridSelection(M,!1);M.enableColumnFit();va=z})();va.beginUpdate();va.setItems(V);va.setFilter(Ud.get("pop_showsize")?L:U);va.endUpdate();(function(){for(var t=0;t<aa.length;++t)ia(aa[t][0]);Aa();me()})();(function(){$(r.ua).change(function(){this.checked?("size"!=Y[3].field&&Y.splice(3,0,fa),$(r.F).show()):("size"==Y[3].field&&Y.splice(3,1),$(r.F).hide());Ud.set("pop_showsize",this.checked);M.beginRender();M.setColumns(Y);va.setFilter(this.checked?L:U);M.endRender()});$(r.V).change(function(){f(this.checked,
!0,!0);Ud.set("pop_preview",this.checked)});$(r.F).mouseenter(function(){$(r.T).show()}).mouseleave(function(){$(r.T).hide()});$(r.F+' input[type="range"]').bind("input",function(){var t=parseInt(this.value);N[D].u=t;if(0>=t||50<t)var z=0;else if(z=N[D],0==z.l.length)z=0;else{var m=(t-1)*(z.l.length-1)/49,v=Math.floor(m);z=v>=z.l.length-1?z.l[z.l.length-1]:z.l[v]+(z.l[v+1]-z.l[v])*(m-v)}N[D].v=z;$(r.T).text(t?"> "+rc(z):"-");va.refresh();u(D,Ia.getCheckedRowsCount())});$(document).on("click",".filter_tab",
function(){var t=$(".active_tab.filter_tab");0!=t.length&&(t.data("RE",$(r.J).val()||""),t.data("exclusive",$(r.K).prop("checked")),t.data("sortcols",M.getSortColumns()),t.removeClass("active_tab"));t=$(this);var z=t.data("RE")||"";$(r.J).val(z);z=t.data("exclusive")||!1;$(r.K).prop("checked",z);z=t.data("sortcols")||[];var m=M.getSortColumns();m=0<z.length&&(0==m.length||z[0].columnId!=m[0].columnId||z[0].sortAsc!=m[0].sortAsc);M.setSortColumns(z);t.addClass("active_tab");D=Number(t.attr("icat"));
t=!1;N[D].S?($(r.W).show(),t=$(r.V).prop("checked")):$(r.W).hide();M.beginRender();m?Ka(va,ua[z[0].columnId],z[0].sortAsc):va.refresh();f(t,!0,!1);M.endRender();Ia.recheckFull();t=$(r.F+' input[type="range"]')[0];z=N[D];t.min="0";t.max="50";t.value=String(z.u);$(r.T).text(z.u?"> "+rc(z.v):"-");k(D);E.find('div[icat="'+D+'"]').addClass("active_exts").siblings().removeClass("active_exts");xa=1});$(document).on("click",r.va+" input:checkbox",function(){if(!$(r.K).is(":checked")){for(var t=this.attributes.fext.value,
z=this.checked,m=[],v=0,C=M.getDataLength();v<C;++v)M.getDataItem(v).fext==t&&m.push(v);Ia.setCheckedRows(m,z);u(D,Ia.getCheckedRowsCount())}});$(r.xa+" li").click(function(){$(r.xa+" .active_tab").removeClass("active_tab");$(".settings_active").removeClass("settings_active");$(this).addClass("active_tab");$("#"+$(this).attr("tab-target")).addClass("settings_active")});$(r.J).bind("input",function(){var t=Mb($(this).val());if(""==t)S=null;else{$(r.J).removeAttr("style");console.log(t);try{var z=new RegExp(t,
"i")}catch(m){console.log(m),$(r.J).attr("style","border: 1px solid rgb(255, 0, 0);")}S=z}Xa()});$(r.K).bind("change",function(){this.checked?E.find(".active_exts input:checkbox").attr("disabled","disabled"):E.find(".active_exts input:checkbox").removeAttr("disabled");Xa()});$(r.sa).click(function(){Da(!1,function(t){t&&window.close()})});$(r.ra).click(function(){Da(!0,function(t){t&&window.close()})});$(r.Ta).click(function(){window.close()});$("input[type=number]").numeric({decimal:!1,negative:!1});
Ud.get("def_addtop")&&$("[name=addtop]").prop("checked",!0);$(r.Ua).click(function(){jb({cmd:"open_options",section:"category"})})})();M.beginRender();M.init();M.autosizeColumns();M.endRender()}function f(L,U,ja){if(Ea!=L){if(Ea=L){qa.rowHeight=64;for(var ia=0;ia<Y.length;++ia)if("url"==Y[ia].field){Y[ia].cssClass="slick-cell-center";break}}else for(qa.rowHeight=25,ia=0;ia<Y.length;++ia)if("url"==Y[ia].field){Y[ia].cssClass="slick-cell-left";break}$(r.Grid).toggleClass("grid-preview",L);0!=U&&M&&
(ja&&M.beginRender(),M.setOptions(qa),M.setColumns(Y),ja&&M.endRender())}}function k(L){L=N[L];var U=new Set;for(var ja of L.aa)U.add(ja);ja=Array.from(U);U=ja.length;L.l=[];ja.sort(function(Aa,Xa){return Aa-Xa});if(10>=U)for(var ia=0;ia<U;++ia)L.l.push(ja[ia]-.1);else for(L.l.push(ja[0]-.1),ia=1;10>ia;++ia)L.l.push(ja[Math.floor(ia*(U-1)/9)]-.1)}function u(L,U,ja){L=$('.filter_tab[icat="'+L+'"]');if(ja){var ia=L.data("sel_cnt")||0;U=0<ja?ia+U:ia-U}ja="";0<U&&(ja=" ("+U+")");L.data("sel_cnt",U);L.find(".tab_selcount").text(ja);
U=$(".filter_tab");for(L=ja=0;L<U.length;++L)ja+=U.eq(L).data("sel_cnt")||0;$(r.sa).prop("disabled",0==ja);$(r.ra).prop("disabled",0==ja)}function q(L){switch(L.cmd){case "add_links":n(L.data),$(r.ab).hide()}}function n(L){function U(m){for(var v=E.find('div[icat="'+m.icat+'"] input:checkbox:checked'),C=v.length,d=0;d<C;++d)if(m.fext==v[d].attributes.fext.value)return!0;return!1}function ja(m){for(var v=9999!=m?G[m].caption:K("extsOthers"),C="filter_tab",d=$(".filter_tab"),h=d.length-1;0<=h;--h){var p=
Number($(d[h]).attr("icat"));if(m>p)break}0>h?(xa||(C+=" active_tab",D=m,d.removeClass("active_tab")),v='<li class="'+C+'" icat="'+m+'"><a href="#">'+v+'<span class="tab_selcount"></span></a></li>',$(r.$a).prepend(v)):(v='<li class="'+C+'" icat="'+m+'"><a href="#">'+v+'<span class="tab_selcount"></span></a></li>',$(d[h]).after(v));d='<div icat="'+m+'"';D==m&&(E.find("div").removeClass("active_exts"),d+=' class="active_exts"');E.append(d+"><ul></ul></div>")}function ia(m,v){v='<li><label><input type="checkbox"  fext="'+
v+'"><span>'+(v||".")+" ("+B[m][v]+")</span></label></li>";var C=E.find('div[icat="'+m+'"] li:last-child');0==C.length||""!=C.find("input").attr("fext")?E.find('div[icat="'+m+'"] ul').append(v):C.before(v)}function Aa(m){if(!m||!ba)return 9999;for(var v=0,C=G.length;v<C;++v)if(ba[v]&&ba[v].test(m))return v;return 9999}if(L&&L.length){for(var Xa=V.length,Da={},Ka={},wa=[],lb=!1,fa=0,ua=L.length;fa<ua;++fa){const m=L[fa];var aa=m.fext||oc(mc(m.url).file).oa||oc(m.desc).oa;aa&&20<aa.length&&(aa="");
if(!Va.test(qc)||!ya.test(aa)){var S=W[m.url];if(void 0!=S){if(m.desc||m.title||m.text)if(aa=va.getItemById(S))m.title||m.text?(aa.desc=aa.desc||m.desc||m.text||m.title,aa.text=aa.text||m.text,aa.title=aa.title||m.title):aa.desc=m.desc}else{m.referer=qc;m.desc=m.desc||m.text||m.title;S=Aa(aa);B[S]||(B[S]={},ja(S));B[S][aa]||(B[S][aa]=0,ia(S,aa));++B[S][aa];m.id=Xa+fa;m.index=m.id;m.icat=S;m.fext=aa;m.size&&-1!=m.size?(N[S].aa.push(m.size),S==D&&(lb=!0)):m.size=-1;var t=U(m);m.sel=t;var z=N[S];t&&
(0==z.u||-1==m.size||m.size>=z.v)&&(Ka[S]?++Ka[S]:Ka[S]=1);Da[S]||(Da[S]={});Da[S][aa]=1;Ta.test(aa)?(m.preview="img",N[S].S=!0):za.test(aa)&&(m.preview="audio",N[S].S=!0);wa.push(m);W[m.url]=m.id}}}L=!1;N[D].S?($(r.W).show(),L=$(r.V).prop("checked")):$(r.W).hide();Ba=!1;M.beginRender();f(L,!0,!1);va.addItems(wa);M.endRender();for(const m in Da)for(const v in Da[m])E.find('input[fext="'+v+'"]').siblings().text((v||".")+" ("+B[m][v]+")");for(const m in Ka)u(m,Ka[m],1);lb&&k(D)}}function g(){$(r.Va).click(function(){jb({cmd:"open_ui"},
function(){window.close()})});$(r.Wa).click(function(){Ud.set("pop_content",0);window.location.href="pop.html"});fe.set("stid",oe);try{pc()&&0==Wa.test(qc)?($(r.wa).hide(),$(r.ta).show(),$(r.ya).addClass("wider"),Promise.all([Vd,ke.load()]).then(()=>{G=he;c();var L=oe;Ea=!1;Ba=!0;D=-1;xa=0;chrome.runtime.onMessage.addListener(q);Pa=0;ra={};N={};B={};W={};V.splice(0,V.length);va.refresh();N[9999]={S:!1,u:0,v:0,l:[],aa:[]};for(var U=0,ja=G.length;U<ja;++U)N[U]={S:!1,u:0,v:0,l:[],aa:[]};chrome.tabs.sendMessage(L,
{cmd:"g_links"});J=!0;location.search.includes("mnu=1")&&0===Ud.get("pop_content")&&chrome.action.setPopup({popup:"/pop/pop.html"})})):($(r.ta).hide(),$(r.wa).show(),$(r.ya).removeClass("wider"))}catch(L){console.log(L)}}function w(){var L=document.getElementById(r.bb),U=document.getElementById(r.Xa),ja=document.getElementById(r.fb),ia=document.getElementById(r.Ya);pc()&&0==Wa.test(qc)?(U.style.display="block",ja.className="wider"):L.style.display="block";ia.style.display="block";ce();Wd();document.body.ondragstart=
()=>!1;document.body.ondrop=()=>!1;ne()}var r={U:"#img_enlarge",Grid:"#links_grid",ab:"#wrap_sniffer_loading",xa:"#settings_tabs",$a:"#filter_tabs",J:"#filter_custom",K:"#filter_exclusive",va:"#ext_filters",sa:"#btn_start",ra:"#btn_addpause",Ta:"#btn_cancel",Ua:"#config_cats",ua:"#cb_show_size",F:"#slider_filesize",T:"#text_filesize",V:"#cb_preview",W:"#cb_preview_wrap",fb:"tot_wrap",bb:"cannot_sniffer",Xa:"can_sniffer",Ya:"wrap_sniffer",ya:"#tot_wrap",wa:"#cannot_sniffer",ta:"#can_sniffer",Va:"#btn_manager",
Wa:"#btn_list"},E,G=[],J=!1,ba=null,Y,qa,M=null,Ia=null,va=null,Q=null,V=[],N={},B={},W={},Ea=!1,Ba=!0,D=-1,xa=0,ra={},Pa=0,Va=RegExp(".*youtube.com.*","i"),ya=RegExp("^(3gp|3g2|asf|avi|f4f|f4i|f4m|f4v|flv|h264|m4v|mkv|mov|mp4|mpg|ogg|ogv|qt|rm|rmvb|ts|vob|webm|wmv)$","i"),Ta=RegExp("^(jpe?g|gif|png|bmp|ico|webp|svg)$","i"),za=RegExp("^(m4a|mp3|oga|ogg|opus|wav|weba)$","i");window.onunload=function(){fe.erase("stid")};var Wa=/chromewebstore\.google\.com|chrome\.google\.com\/webstore/;window.addEventListener("load",
function(){1751241692193<le||chrome.tabs.query({currentWindow:!0,active:!0},function(L){L&&L.length&&(qc=L[0].url,oe=L[0].id);w();g();$d("page_view",{page_title:document.title,page_location:location.href});jb({cmd:"gr"})})})})();
